'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _createClass = _interopDefault(require('@babel/runtime/helpers/createClass'));
var Stream = require('stream');
var Stream__default = _interopDefault(Stream);
var _regeneratorRuntime = _interopDefault(require('@babel/runtime/regenerator'));
var _asyncToGenerator = _interopDefault(require('@babel/runtime/helpers/asyncToGenerator'));
var _inheritsLoose = _interopDefault(require('@babel/runtime/helpers/inheritsLoose'));
var CombinedStream = _interopDefault(require('combined-stream'));
var util = _interopDefault(require('util'));
var path = _interopDefault(require('path'));
var fs = _interopDefault(require('fs'));
var mime = _interopDefault(require('mime-types'));
var asynckit = _interopDefault(require('asynckit'));
var log = _interopDefault(require('electron-log'));
var http = _interopDefault(require('http'));
var Url = _interopDefault(require('url'));
var cacheManager = _interopDefault(require('cache-manager'));
var electron = require('electron');
var asyncMutex = require('async-mutex');
var _assertThisInitialized = _interopDefault(require('@babel/runtime/helpers/assertThisInitialized'));
var _asyncIterator = _interopDefault(require('@babel/runtime/helpers/asyncIterator'));
var events = require('events');
var uuid = require('uuid');
var https = _interopDefault(require('https'));
var zlib = _interopDefault(require('zlib'));

var Readable = Stream__default.Readable;
var BUFFER = Symbol('buffer');
var TYPE = Symbol('type');

var Blob = /*#__PURE__*/function () {
  function Blob() {
    this[TYPE] = '';
    var blobParts = arguments[0];
    var options = arguments[1];
    var buffers = [];
    var size = 0;

    if (blobParts) {
      var a = blobParts;
      var length = Number(a.length);

      for (var i = 0; i < length; i++) {
        var element = a[i];
        var buffer = void 0;

        if (element instanceof Buffer) {
          buffer = element;
        } else if (ArrayBuffer.isView(element)) {
          buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
        } else if (element instanceof ArrayBuffer) {
          buffer = Buffer.from(element);
        } else if (element instanceof Blob) {
          buffer = element[BUFFER];
        } else {
          buffer = Buffer.from(typeof element === 'string' ? element : String(element));
        }

        size += buffer.length;
        buffers.push(buffer);
      }
    }

    this[BUFFER] = Buffer.concat(buffers);
    var type = options && options.type !== undefined && String(options.type).toLowerCase();

    if (type && !/[^\u0020-\u007E]/.test(type)) {
      this[TYPE] = type;
    }
  }

  var _proto = Blob.prototype;

  _proto.text = function text() {
    return Promise.resolve(this[BUFFER].toString());
  };

  _proto.arrayBuffer = function arrayBuffer() {
    var buf = this[BUFFER];
    var ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    return Promise.resolve(ab);
  };

  _proto.stream = function stream() {
    var readable = new Readable();

    readable._read = function () {};

    readable.push(this[BUFFER]);
    readable.push(null);
    return readable;
  };

  _proto.toString = function toString() {
    return '[object Blob]';
  };

  _proto.slice = function slice() {
    var size = this.size;
    var start = arguments[0];
    var end = arguments[1];
    var relativeStart, relativeEnd;

    if (start === undefined) {
      relativeStart = 0;
    } else if (start < 0) {
      relativeStart = Math.max(size + start, 0);
    } else {
      relativeStart = Math.min(start, size);
    }

    if (end === undefined) {
      relativeEnd = size;
    } else if (end < 0) {
      relativeEnd = Math.max(size + end, 0);
    } else {
      relativeEnd = Math.min(end, size);
    }

    var span = Math.max(relativeEnd - relativeStart, 0);
    var buffer = this[BUFFER];
    var slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
    var blob = new Blob([], {
      type: arguments[2]
    });
    blob[BUFFER] = slicedBuffer;
    return blob;
  };

  _createClass(Blob, [{
    key: "size",
    get: function get() {
      return this[BUFFER].length;
    }
  }, {
    key: "type",
    get: function get() {
      return this[TYPE];
    }
  }]);

  return Blob;
}();
Object.defineProperties(Blob.prototype, {
  size: {
    enumerable: true
  },
  type: {
    enumerable: true
  },
  slice: {
    enumerable: true
  }
});
Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
  value: 'Blob',
  writable: false,
  enumerable: false,
  configurable: true
});

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * Create FetchError instance
 *
 * @param   String      message      Error message for human
 * @param   String      type         Error type for machine
 * @param   String      systemError  For Node.js system error
 * @return  FetchError
 */
function FetchError(message, type, systemError) {
  Error.call(this, message);
  this.message = message;
  this.type = type; // when err.type is `system`, err.code contains system error code

  if (systemError) {
    this.code = this.errno = systemError.code;
  } // hide custom error implementation details from end-users


  Error.captureStackTrace(this, this.constructor);
}
FetchError.prototype = Object.create(Error.prototype);
FetchError.prototype.constructor = FetchError;
FetchError.prototype.name = 'FetchError';

util.inherits(FormData, CombinedStream);

var ReadableBlob = /*#__PURE__*/function (_Readable) {
  _inheritsLoose(ReadableBlob, _Readable);

  function ReadableBlob(options, blob) {
    var _this;

    _this = _Readable.call(this, options) || this;
    _this.blobReadableStream = blob.stream();
    _this.ReadableStreamDefaultReader = _this.blobReadableStream.getReader();
    return _this;
  }

  var _proto = ReadableBlob.prototype;

  _proto._read = /*#__PURE__*/function () {
    var _read2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(size) {
      var stop, readResults, pushResult;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              log.info('ReadableBlob._read() entered, size is: %o', size);
              stop = false;

            case 2:
              if (stop) {
                _context.next = 21;
                break;
              }

              log.info('ReadableBlob top of loop, calling ReadableStreamDefaultReader.read()');
              _context.next = 6;
              return this.ReadableStreamDefaultReader.read();

            case 6:
              readResults = _context.sent;
              log.info('ReadableStreamDefaultReader.read() results is: %o', readResults);

              if (!readResults.done) {
                _context.next = 14;
                break;
              }

              _context.next = 11;
              return this.push(null);

            case 11:
              stop = true;
              _context.next = 19;
              break;

            case 14:
              _context.next = 16;
              return this.push(readResults.value);

            case 16:
              pushResult = _context.sent;
              log.info('ReadableBlob._read() push result is: %o', pushResult);

              if (!pushResult) {
                stop = true;
                log.info('ReadableBlob stopping loop');
              }

            case 19:
              _context.next = 2;
              break;

            case 21:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function _read(_x) {
      return _read2.apply(this, arguments);
    }

    return _read;
  }();

  return ReadableBlob;
}(Stream.Readable);
/**
 * Create readable "multipart/form-data" streams.
 * Can be used to submit forms
 * and file uploads to other web applications.
 *
 * @constructor
 * @param {Object} options - Properties to be added/overriden for FormData and CombinedStream
 */


function FormData(options) {
  if (!(this instanceof FormData)) {
    return new FormData(options);
  }

  this._ZITI = true;
  this._overheadLength = 0;
  this._valueLength = 0;
  this._valuesToMeasure = [];
  CombinedStream.call(this);
  options = options || {
    pauseStreams: false
  };

  for (var option in options) {
    this[option] = options[option];
  }
}
FormData.LINE_BREAK = '\r\n';
FormData.DEFAULT_CONTENT_TYPE = 'application/octet-stream';

FormData.prototype.append = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(field, value, options) {
    var append, header, footer, readableBlob;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            options = options || {}; // allow filename as single option

            if (typeof options == 'string') {
              options = {
                filename: options
              };
            }

            append = CombinedStream.prototype.append.bind(this); // all that streamy business can't handle numbers

            if (typeof value == 'number') {
              value = '' + value;
            } // https://github.com/felixge/node-form-data/issues/38


            if (!util.isArray(value)) {
              _context2.next = 7;
              break;
            }

            // Please convert your array into string
            // the way web server expects it
            this._error(new Error('Arrays are not supported.'));

            return _context2.abrupt("return");

          case 7:
            header = this._multiPartHeader(field, value, options);
            footer = this._multiPartFooter();
            append(header);
            /**
             *  The following currently assumes that the 'value' parm is a native File object.
             */
            // log.info('value is: %o', value);
            // log.info('value.path is: %o', value.path);
            // log.info('value.size is: %o', value.size);
            // log.info('typeof value is: %o', typeof value);

            if (typeof value === "object" && typeof value.name == 'string' && typeof value.path == 'string' && typeof value.type == 'string') {
              // is it a File?
              // log.info('***** FILE *****');
              // debugger
              options.knownLength = value.size;
              append(fs.createReadStream(value.path));
            } else if (typeof value === "object" && typeof value.name == 'string') {
              // is it a Blob?
              // log.info('***** BLOB *****');
              // debugger
              // var readable = new Readable().wrap(value.stream());
              // debugger
              readableBlob = new ReadableBlob({}, value);
              options.knownLength = value.size;
              append(readableBlob); //   var arrayBuffer = await value.arrayBuffer();
              //   debugger
              //   const buffer = Buffer.from(arrayBuffer);
              //   const readable = new Readable();
              //   readable._read = () => {};
              //   readable.push(buffer);
              //   readable.push(null);
              //   options.knownLength = value.size;
              //   append(readable);
              // // } else if (value.name) {
              // //   append(value.stream);
            } else {
              // log.info('***** STRING *****');
              options.knownLength = value.size;
              append(value); // just a string
            }

            append(footer); // pass along options.knownLength

            this._trackLength(header, value, options);

          case 13:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function (_x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

FormData.prototype._trackLength = function (header, value, options) {
  var valueLength = 0; // used w/ getLengthSync(), when length is known.
  // e.g. for streaming directly from a remote server,
  // w/ a known file a size, and not wanting to wait for
  // incoming file to finish to get its size.

  if (options.knownLength != null) {
    valueLength += +options.knownLength;
  } else if (Buffer.isBuffer(value)) {
    valueLength = value.length;
  } else if (typeof value === 'string') {
    valueLength = Buffer.byteLength(value);
  }

  this._valueLength += valueLength; // @check why add CRLF? does this account for custom/multiple CRLFs?

  this._overheadLength += Buffer.byteLength(header) + FormData.LINE_BREAK.length; // empty or either doesn't have path or not an http response

  if (!value || !value.path && !(value.readable && value.hasOwnProperty('httpVersion'))) {
    return;
  } // no need to bother with the length


  if (!options.knownLength) {
    this._valuesToMeasure.push(value);
  }
};

FormData.prototype._lengthRetriever = function (value, callback) {
  if (value.hasOwnProperty('fd')) {
    // take read range into a account
    // `end` = Infinity –> read file till the end
    //
    // TODO: Looks like there is bug in Node fs.createReadStream
    // it doesn't respect `end` options without `start` options
    // Fix it when node fixes it.
    // https://github.com/joyent/node/issues/7819
    if (value.end != undefined && value.end != Infinity && value.start != undefined) {
      // when end specified
      // no need to calculate range
      // inclusive, starts with 0
      callback(null, value.end + 1 - (value.start ? value.start : 0)); // not that fast snoopy
    } else {
      // still need to fetch file size from fs
      fs.stat(value.path, function (err, stat) {
        var fileSize;

        if (err) {
          callback(err);
          return;
        } // update final size based on the range options


        fileSize = stat.size - (value.start ? value.start : 0);
        callback(null, fileSize);
      });
    } // or http response

  } else if (value.hasOwnProperty('httpVersion')) {
    callback(null, +value.headers['content-length']); // or request stream http://github.com/mikeal/request
  } else if (value.hasOwnProperty('httpModule')) {
    // wait till response come back
    value.on('response', function (response) {
      value.pause();
      callback(null, +response.headers['content-length']);
    });
    value.resume(); // something else
  } else {
    callback('Unknown stream');
  }
};

FormData.prototype._multiPartHeader = function (field, value, options) {
  // custom header specified (as string)?
  // it becomes responsible for boundary
  // (e.g. to handle extra CRLFs on .NET servers)
  if (typeof options.header == 'string') {
    return options.header;
  }

  var contentDisposition = this._getContentDisposition(value, options);

  var contentType = this._getContentType(value, options);

  var contents = '';
  var headers = {
    // add custom disposition as third element or keep it two elements if not
    'Content-Disposition': ['form-data', 'name="' + field + '"'].concat(contentDisposition || []),
    // if no content type. allow it to be empty array
    'Content-Type': [].concat(contentType || [])
  };
  var header;

  for (var prop in headers) {
    if (!headers.hasOwnProperty(prop)) continue;
    header = headers[prop]; // skip nullish headers.

    if (header == null) {
      continue;
    } // convert all headers to arrays.


    if (!Array.isArray(header)) {
      header = [header];
    } // add non-empty headers.


    if (header.length) {
      contents += prop + ': ' + header.join('; ') + FormData.LINE_BREAK;
    }
  }

  return '--' + this.getBoundary() + FormData.LINE_BREAK + contents + FormData.LINE_BREAK;
};

FormData.prototype._getContentDisposition = function (value, options) {
  var filename, contentDisposition;

  if (typeof options.filepath === 'string') {
    // custom filepath for relative paths
    filename = path.normalize(options.filepath).replace(/\\/g, '/');
  } else if (options.filename || value.name || value.path) {
    // custom filename take precedence
    // formidable and the browser add a name property
    // fs- and request- streams have path property
    filename = path.basename(options.filename || value.name || value.path);
  } else if (value.readable && value.hasOwnProperty('httpVersion')) {
    // or try http response
    filename = path.basename(value.client._httpMessage.path || '');
  }

  if (filename) {
    contentDisposition = 'filename="' + filename + '"';
  }

  return contentDisposition;
};

FormData.prototype._getContentType = function (value, options) {
  // use custom content-type above all
  var contentType = options.contentType; // or try `name` from formidable, browser

  if (!contentType && value.name) {
    contentType = mime.lookup(value.name);
  } // or try `path` from fs-, request- streams


  if (!contentType && value.path) {
    contentType = mime.lookup(value.path);
  } // or if it's http-reponse


  if (!contentType && value.readable && value.hasOwnProperty('httpVersion')) {
    contentType = value.headers['content-type'];
  } // or guess it from the filepath or filename


  if (!contentType && (options.filepath || options.filename)) {
    contentType = mime.lookup(options.filepath || options.filename);
  } // fallback to the default content type if `value` is not simple value


  if (!contentType && typeof value == 'object') {
    contentType = FormData.DEFAULT_CONTENT_TYPE;
  }

  return contentType;
};

FormData.prototype._multiPartFooter = function () {
  return function (next) {
    var footer = FormData.LINE_BREAK;
    var lastPart = this._streams.length === 0;

    if (lastPart) {
      footer += this._lastBoundary();
    }

    next(footer);
  }.bind(this);
};

FormData.prototype._lastBoundary = function () {
  return '--' + this.getBoundary() + '--' + FormData.LINE_BREAK;
};

FormData.prototype.getHeaders = function (userHeaders) {
  var header;
  var formHeaders = {
    'content-type': 'multipart/form-data; boundary=' + this.getBoundary()
  };

  for (header in userHeaders) {
    if (userHeaders.hasOwnProperty(header)) {
      formHeaders[header.toLowerCase()] = userHeaders[header];
    }
  }

  return formHeaders;
};

FormData.prototype.getBoundary = function () {
  if (!this._boundary) {
    this._generateBoundary();
  }

  return this._boundary;
};

FormData.prototype.getBuffer = function () {
  var dataBuffer = new Buffer.alloc(0);
  var boundary = this.getBoundary(); // Create the form content. Add Line breaks to the end of data.

  for (var i = 0, len = this._streams.length; i < len; i++) {
    if (typeof this._streams[i] !== 'function') {
      // Add content to the buffer.
      if (Buffer.isBuffer(this._streams[i])) {
        dataBuffer = Buffer.concat([dataBuffer, this._streams[i]]);
      } else {
        dataBuffer = Buffer.concat([dataBuffer, Buffer.from(this._streams[i])]);
      } // Add break after content.


      if (typeof this._streams[i] !== 'string' || this._streams[i].substring(2, boundary.length + 2) !== boundary) {
        dataBuffer = Buffer.concat([dataBuffer, Buffer.from(FormData.LINE_BREAK)]);
      }
    }
  } // Add the footer and return the Buffer object.


  return Buffer.concat([dataBuffer, Buffer.from(this._lastBoundary())]);
};

FormData.prototype._generateBoundary = function () {
  // This generates a 50 character boundary similar to those used by Firefox.
  // They are optimized for boyer-moore parsing.
  var boundary = '--------------------------';

  for (var i = 0; i < 24; i++) {
    boundary += Math.floor(Math.random() * 10).toString(16);
  }

  this._boundary = boundary;
}; // Note: getLengthSync DOESN'T calculate streams length
// As workaround one can calculate file size manually
// and add it as knownLength option


FormData.prototype.getLengthSync = function () {
  var knownLength = this._overheadLength + this._valueLength; // Don't get confused, there are 3 "internal" streams for each keyval pair
  // so it basically checks if there is any value added to the form

  if (this._streams.length) {
    knownLength += this._lastBoundary().length;
  } // https://github.com/form-data/form-data/issues/40


  if (!this.hasKnownLength()) {
    // Some async length retrievers are present
    // therefore synchronous length calculation is false.
    // Please use getLength(callback) to get proper length
    this._error(new Error('Cannot calculate proper length in synchronous way.'));
  }

  return knownLength;
}; // Public API to check if length of added values is known
// https://github.com/form-data/form-data/issues/196
// https://github.com/form-data/form-data/issues/262


FormData.prototype.hasKnownLength = function () {
  var hasKnownLength = true;

  if (this._valuesToMeasure.length) {
    hasKnownLength = false;
  }

  return hasKnownLength;
};

FormData.prototype.getLength = function (cb) {
  var knownLength = this._overheadLength + this._valueLength;

  if (this._streams.length) {
    knownLength += this._lastBoundary().length;
  }

  if (!this._valuesToMeasure.length) {
    process.nextTick(cb.bind(this, null, knownLength));
    return;
  }

  asynckit.parallel(this._valuesToMeasure, this._lengthRetriever, function (err, values) {
    if (err) {
      cb(err);
      return;
    }

    values.forEach(function (length) {
      knownLength += length;
    });
    cb(null, knownLength);
  });
};

FormData.prototype._error = function (err) {
  if (!this.error) {
    this.error = err;
    this.pause();
    this.emit('error', err);
  }
};

FormData.prototype.toString = function () {
  return '[object FormData]';
};

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var convert;

try {
  convert = require('encoding').convert;
} catch (e) {}

var INTERNALS = Symbol('Body internals'); // fix an issue where "PassThrough" isn't a named export for node <10

var PassThrough = Stream__default.PassThrough;
/**
 * Body mixin
 *
 * Ref: https://fetch.spec.whatwg.org/#body
 *
 * @param   Stream  body  Readable stream
 * @param   Object  opts  Response options
 * @return  Void
 */

function Body(body, _temp) {
  var _this = this;

  var _ref = _temp === void 0 ? {} : _temp,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 0 : _ref$size,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;

  // log.info('Body mixin entered, body: %o', body);
  if (body == null) {
    // body is undefined or null
    body = null;
  } else if (isURLSearchParams(body)) {
    // body is a URLSearchParams
    body = Buffer.from(body.toString());
  } else if (isBlob(body)) ; else if (Buffer.isBuffer(body)) ; else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
    // body is ArrayBuffer
    body = Buffer.from(body);
  } else if (ArrayBuffer.isView(body)) {
    // body is ArrayBufferView
    body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
  } else if (body instanceof Stream__default) ; else {
    // log.info('Body is a string: [%o]', body);
    // none of the above
    // coerce to string then buffer
    body = Buffer.from(String(body)); // log.info('Body as a Buffer: [%o]', body);
    // log.info('Body as a Buffer.toString: [%o]', body.toString());
  }

  this[INTERNALS] = {
    body,
    disturbed: false,
    error: null
  };
  this.size = size;
  this.timeout = timeout;

  if (body instanceof Stream__default) {
    body.on('error', function (err) {
      var error = err.name === 'AbortError' ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, 'system', err);
      _this[INTERNALS].error = error;
    });
  }
}
Body.prototype = {
  get body() {
    return this[INTERNALS].body;
  },

  get bodyUsed() {
    return this[INTERNALS].disturbed;
  },

  /**
   * Decode response as ArrayBuffer
   *
   * @return  Promise
   */
  arrayBuffer() {
    return consumeBody.call(this).then(function (buf) {
      return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    });
  },

  /**
   * Return raw response as Blob
   *
   * @return Promise
   */
  blob() {
    var ct = this.headers && this.headers.get('content-type') || '';
    return consumeBody.call(this).then(function (buf) {
      return Object.assign( // Prevent copying
      new Blob([], {
        type: ct.toLowerCase()
      }), {
        [BUFFER]: buf
      });
    });
  },

  /**
   * Decode response as json
   *
   * @return  Promise
   */
  json() {
    var _this2 = this;

    return consumeBody.call(this).then(function (buffer) {
      try {
        return JSON.parse(buffer.toString());
      } catch (err) {
        return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, 'invalid-json'));
      }
    });
  },

  /**
   * Decode response as text
   *
   * @return  Promise
   */
  text() {
    return consumeBody.call(this).then(function (buffer) {
      return buffer.toString();
    });
  },

  /**
   * Decode response as buffer (non-spec api)
   *
   * @return  Promise
   */
  buffer() {
    return consumeBody.call(this);
  },

  /**
   * Decode response as text, while automatically detecting the encoding and
   * trying to decode to UTF-8 (non-spec api)
   *
   * @return  Promise
   */
  textConverted() {
    var _this3 = this;

    return consumeBody.call(this).then(function (buffer) {
      return convertBody(buffer, _this3.headers);
    });
  }

}; // In browsers, all properties are enumerable.

Object.defineProperties(Body.prototype, {
  body: {
    enumerable: true
  },
  bodyUsed: {
    enumerable: true
  },
  arrayBuffer: {
    enumerable: true
  },
  blob: {
    enumerable: true
  },
  json: {
    enumerable: true
  },
  text: {
    enumerable: true
  }
});

Body.mixIn = function (proto) {
  for (var _iterator = _createForOfIteratorHelperLoose(Object.getOwnPropertyNames(Body.prototype)), _step; !(_step = _iterator()).done;) {
    var name = _step.value;

    // istanbul ignore else: future proof
    if (!(name in proto)) {
      var desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
      Object.defineProperty(proto, name, desc);
    }
  }
};
/**
 * Consume and convert an entire Body to a Buffer.
 *
 * Ref: https://fetch.spec.whatwg.org/#concept-body-consume-body
 *
 * @return  Promise
 */


function consumeBody() {
  var _this4 = this;

  // log.info('consumeBody() entered');
  if (this[INTERNALS].disturbed) {
    log.error('consumeBody() this[INTERNALS].disturbed, body used already for: %s', this.url);
    return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
  }

  this[INTERNALS].disturbed = true;

  if (this[INTERNALS].error) {
    log.error('consumeBody() this[INTERNALS].error: %o', this[INTERNALS].error);
    return Body.Promise.reject(this[INTERNALS].error);
  }

  var body = this.body; // body is null

  if (body === null) {
    return Body.Promise.resolve(Buffer.alloc(0));
  } // body is blob


  if (isBlob(body)) {
    body = body.stream();
  } // body is buffer


  if (Buffer.isBuffer(body)) {
    return Body.Promise.resolve(body);
  } // istanbul ignore if: should never happen


  if (!(body instanceof Stream__default)) {
    return Body.Promise.resolve(Buffer.alloc(0));
  } // body is stream
  // get ready to actually consume the body


  var accum = [];
  var accumBytes = 0;
  var abort = false;
  return new Body.Promise(function (resolve, reject) {
    var resTimeout; // allow timeout on slow response body

    if (_this4.timeout) {
      resTimeout = setTimeout(function () {
        abort = true;
        reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, 'body-timeout'));
      }, _this4.timeout);
    } // handle stream errors


    body.on('error', function (err) {
      log.error('consumeBody() in on.error: %o', err);

      if (err.name === 'AbortError') {
        // if the request was aborted, reject with this Error
        abort = true;
        reject(err);
      } else {
        // other errors, such as incorrect content-encoding
        reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, 'system', err));
      }
    });
    body.on('data', function (chunk) {
      if (abort || chunk === null) {
        return;
      }

      if (_this4.size && accumBytes + chunk.length > _this4.size) {
        abort = true;
        log.error('consumeBody() in on.data: content size over limit: %o', _this4.size);
        reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, 'max-size'));
        return;
      }

      accumBytes += chunk.length;
      accum.push(chunk);
    });
    body.on('end', function () {
      if (abort) {
        return;
      }

      clearTimeout(resTimeout);

      try {
        resolve(Buffer.concat(accum, accumBytes));
      } catch (err) {
        log.error('consumeBody() Could not create Buffer from response body for %s: %s', _this4.url, err.message); // handle streams that have accumulated too much data (issue #414)

        reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, 'system', err));
      }
    });
  });
}
/**
 * Detect buffer encoding and convert to target encoding
 * ref: http://www.w3.org/TR/2011/WD-html5-20110113/parsing.html#determining-the-character-encoding
 *
 * @param   Buffer  buffer    Incoming buffer
 * @param   String  encoding  Target encoding
 * @return  String
 */


function convertBody(buffer, headers) {
  if (typeof convert !== 'function') {
    throw new Error('The package `encoding` must be installed to use the textConverted() function');
  }

  var ct = headers.get('content-type');
  var charset = 'utf-8';
  var res, str; // header

  if (ct) {
    res = /charset=([^;]*)/i.exec(ct);
  } // no charset in content type, peek at response body for at most 1024 bytes


  str = buffer.slice(0, 1024).toString(); // html5

  if (!res && str) {
    res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str);
  } // html4


  if (!res && str) {
    res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str);

    if (!res) {
      res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str);

      if (res) {
        res.pop(); // drop last quote
      }
    }

    if (res) {
      res = /charset=(.*)/i.exec(res.pop());
    }
  } // xml


  if (!res && str) {
    res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str);
  } // found charset


  if (res) {
    charset = res.pop(); // prevent decode issues when sites use incorrect encoding
    // ref: https://hsivonen.fi/encoding-menu/

    if (charset === 'gb2312' || charset === 'gbk') {
      charset = 'gb18030';
    }
  } // turn raw buffers into a single utf-8 buffer


  return convert(buffer, 'UTF-8', charset).toString();
}
/**
 * Detect a URLSearchParams object
 * ref: https://github.com/bitinn/node-fetch/issues/296#issuecomment-307598143
 *
 * @param   Object  obj     Object to detect by type or brand
 * @return  String
 */


function isURLSearchParams(obj) {
  // Duck-typing as a necessary condition.
  if (typeof obj !== 'object' || typeof obj.append !== 'function' || typeof obj.delete !== 'function' || typeof obj.get !== 'function' || typeof obj.getAll !== 'function' || typeof obj.has !== 'function' || typeof obj.set !== 'function') {
    return false;
  } // Brand-checking and more duck-typing as optional condition.


  return obj.constructor.name === 'URLSearchParams' || Object.prototype.toString.call(obj) === '[object URLSearchParams]' || typeof obj.sort === 'function';
}
/**
 * Check if `obj` is a W3C `Blob` object (which `File` inherits from)
 * @param  {*} obj
 * @return {boolean}
 */


function isBlob(obj) {
  return typeof obj === 'object' && typeof obj.arrayBuffer === 'function' && typeof obj.type === 'string' && typeof obj.stream === 'function' && typeof obj.constructor === 'function' && typeof obj.constructor.name === 'string' && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
}
/**
 * Clone body given Res/Req instance
 *
 * @param   Mixed  instance  Response or Request instance
 * @return  Mixed
 */


function clone(instance) {
  var p1, p2;
  var body = instance.body; // don't allow cloning a used body

  if (instance.bodyUsed) {
    throw new Error('cannot clone body after it is used');
  } // check that body is a stream and not form-data object
  // note: we can't clone the form-data object without having it as a dependency


  if (body instanceof Stream__default && typeof body.getBoundary !== 'function') {
    // tee instance body
    p1 = new PassThrough();
    p2 = new PassThrough();
    body.pipe(p1);
    body.pipe(p2); // set instance body to teed body and return the other teed body

    instance[INTERNALS].body = p1;
    body = p2;
  }

  return body;
}
/**
 * Performs the operation "extract a `Content-Type` value from |object|" as
 * specified in the specification:
 * https://fetch.spec.whatwg.org/#concept-bodyinit-extract
 *
 * This function assumes that instance.body is present.
 *
 * @param   Mixed  instance  Any options.body input
 */

function extractContentType(body) {
  // log.info('extractContentType() entered for body: %o', body);
  if (body === null) {
    // body is null
    return null;
  } else if (typeof body === 'string') {
    // body is string
    return 'text/plain;charset=UTF-8';
  } else if (isURLSearchParams(body)) {
    // body is a URLSearchParams
    return 'application/x-www-form-urlencoded;charset=UTF-8';
  } else if (isBlob(body)) {
    // body is blob
    return body.type || null;
  } else if (Buffer.isBuffer(body)) {
    // body is buffer
    return null;
  } else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
    // body is ArrayBuffer
    return null;
  } else if (ArrayBuffer.isView(body)) {
    // body is ArrayBufferView
    return null;
  } else if (typeof body.getBoundary === 'function') {
    // detect form data input from form-data module
    return `multipart/form-data;boundary=${body.getBoundary()}`;
  } else if (typeof body === 'object' && typeof body.getAll === 'function') {
    // detect FormData object
    log.info('extractContentType() FormData DETECTED for: %o', body);
    var form = new FormData();

    for (var _iterator2 = _createForOfIteratorHelperLoose(body.keys()), _step2; !(_step2 = _iterator2()).done;) {
      var key = _step2.value;
      log.info('key is: ', key);
      log.info('val is: ', body.get(key));
      form.append(key, body.get(key));
    }

    log.info('form is: %o', form);
    log.info('getHeaders() says: %o', form.getHeaders());
    return `multipart/form-data;boundary=${form.getBoundary()}`; // return null;
  } else if (body instanceof Stream__default) {
    // body is stream
    // can't really do much about this
    return null;
  } else {
    // Body constructor defaults other things to string
    return 'text/plain;charset=UTF-8';
  }
}
/**
 * The Fetch Standard treats this as if "total bytes" is a property on the body.
 * For us, we have to explicitly get it with a function.
 *
 * ref: https://fetch.spec.whatwg.org/#concept-body-total-bytes
 *
 * @param   Body    instance   Instance of Body
 * @return  Number?            Number of bytes, or null if not possible
 */

function getTotalBytes(instance) {
  var body = instance.body;

  if (body === null) {
    // body is null
    return 0;
  } else if (isBlob(body)) {
    return body.size;
  } else if (Buffer.isBuffer(body)) {
    // body is buffer
    return body.length;
  } else if (body && typeof body.getLengthSync === 'function') {
    // detect form data input from form-data module
    if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
    body.hasKnownLength && body.hasKnownLength()) ; // 2.x
    // return body.getLengthSync();
    // log.info('getTotalBytes() body.getLengthSync(), size unknown');


    return null;
  } else {
    // log.info('getTotalBytes() body is stream, size unknown');
    // body is stream
    return null;
  }
}
/**
 * Write a Body to a Node.js WritableStream (e.g. http.Request) object.
 *
 * @param   Body    instance   Instance of Body
 * @return  Void
 */

function writeToStream(_x, _x2) {
  return _writeToStream.apply(this, arguments);
} // expose Promise

function _writeToStream() {
  _writeToStream = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(dest, instance) {
    var body;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            body = instance.body;

            if (!(body === null)) {
              _context.next = 5;
              break;
            }

            // body is null
            dest.end();
            _context.next = 15;
            break;

          case 5:
            if (!isBlob(body)) {
              _context.next = 9;
              break;
            }

            // log.info('writeToStream: body is a BLOB');
            body.stream().pipe(dest);
            _context.next = 15;
            break;

          case 9:
            if (!Buffer.isBuffer(body)) {
              _context.next = 14;
              break;
            }

            _context.next = 12;
            return dest.write(body);

          case 12:
            _context.next = 15;
            break;

          case 14:
            // log.info('writeToStream: body is a STREAM: %o', body);
            // body is stream
            body.pipe(dest); // let stop = false;
            // while (!stop) {
            //   log.info('writeToStream: top of loop, calling body.read()');
            //   let readResults = await body.read();
            //   log.info('writeToStream: readResults: %o', readResults);
            //   if (readResults.done) {
            // 	dest.end();
            // 	stop = true;
            //   } else {
            // 	await dest.write(readResults.value);
            //   }
            // }

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _writeToStream.apply(this, arguments);
}

Body.Promise = global.Promise;

function _createForOfIteratorHelperLoose$1(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$1(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
var invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;

function validateName(name) {
  name = `${name}`;

  if (invalidTokenRegex.test(name) || name === '') {
    throw new TypeError(`${name} is not a legal HTTP header name`);
  }
}

function validateValue(value) {
  value = `${value}`;

  if (invalidHeaderCharRegex.test(value)) {
    throw new TypeError(`${value} is not a legal HTTP header value`);
  }
}
/**
 * Find the key in the map object given a header name.
 *
 * Returns undefined if not found.
 *
 * @param   String  name  Header name
 * @return  String|Undefined
 */


function find(map, name) {
  name = name.toLowerCase();

  for (var key in map) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }

  return undefined;
}

var MAP = Symbol('map');

var Headers = /*#__PURE__*/function () {
  /**
   * Headers class
   *
   * @param   Object  headers  Response headers
   * @return  Void
   */
  function Headers(init) {
    if (init === void 0) {
      init = undefined;
    }

    this[MAP] = Object.create(null);

    if (init instanceof Headers) {
      var rawHeaders = init.raw();
      var headerNames = Object.keys(rawHeaders);

      for (var _i = 0, _headerNames = headerNames; _i < _headerNames.length; _i++) {
        var headerName = _headerNames[_i];

        for (var _iterator = _createForOfIteratorHelperLoose$1(rawHeaders[headerName]), _step; !(_step = _iterator()).done;) {
          var value = _step.value;
          this.append(headerName, value);
        }
      }

      return;
    } // We don't worry about converting prop to ByteString here as append()
    // will handle it.


    if (init == null) ; else if (typeof init === 'object') {
      var method = init[Symbol.iterator];

      if (method != null) {
        if (typeof method !== 'function') {
          throw new TypeError('Header pairs must be iterable');
        } // sequence<sequence<ByteString>>
        // Note: per spec we have to first exhaust the lists then process them


        var pairs = [];

        for (var _iterator2 = _createForOfIteratorHelperLoose$1(init), _step2; !(_step2 = _iterator2()).done;) {
          var _pair = _step2.value;

          if (typeof _pair !== 'object' || typeof _pair[Symbol.iterator] !== 'function') {
            throw new TypeError('Each header pair must be iterable');
          }

          pairs.push(Array.from(_pair));
        }

        for (var _i2 = 0, _pairs = pairs; _i2 < _pairs.length; _i2++) {
          var pair = _pairs[_i2];

          if (pair.length !== 2) {
            throw new TypeError('Each header pair must be a name/value tuple');
          }

          this.append(pair[0], pair[1]);
        }
      } else {
        // record<ByteString, ByteString>
        for (var _i3 = 0, _Object$keys = Object.keys(init); _i3 < _Object$keys.length; _i3++) {
          var key = _Object$keys[_i3];
          var _value = init[key];
          this.append(key, _value);
        }
      }
    } else {
      throw new TypeError('Provided initializer must be an object');
    }
  }
  /**
   * Return combined header value given name
   *
   * @param   String  name  Header name
   * @return  Mixed
   */


  var _proto = Headers.prototype;

  _proto.get = function get(name) {
    name = `${name}`;
    validateName(name);
    var key = find(this[MAP], name);

    if (key === undefined) {
      return null;
    }

    return this[MAP][key].join(', ');
  }
  /**
   * Iterate over all headers
   *
   * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
   * @param   Boolean   thisArg   `this` context for callback function
   * @return  Void
   */
  ;

  _proto.forEach = function forEach(callback, thisArg) {
    if (thisArg === void 0) {
      thisArg = undefined;
    }

    var pairs = getHeaders(this);
    var i = 0;

    while (i < pairs.length) {
      var _pairs$i = pairs[i],
          name = _pairs$i[0],
          value = _pairs$i[1];
      callback.call(thisArg, value, name, this);
      pairs = getHeaders(this);
      i++;
    }
  }
  /**
   * Overwrite header values given name
   *
   * @param   String  name   Header name
   * @param   String  value  Header value
   * @return  Void
   */
  ;

  _proto.set = function set(name, value) {
    name = `${name}`;
    value = `${value}`;
    validateName(name);
    validateValue(value);
    var key = find(this[MAP], name);
    this[MAP][key !== undefined ? key : name] = [value];
  }
  /**
   * Append a value onto existing header
   *
   * @param   String  name   Header name
   * @param   String  value  Header value
   * @return  Void
   */
  ;

  _proto.append = function append(name, value) {
    name = `${name}`; // name = name.toLowerCase();

    value = `${value}`;
    validateName(name);
    validateValue(value);
    var key = find(this[MAP], name);

    if (key !== undefined) {
      this[MAP][key].push(value);
    } else {
      this[MAP][name] = [value];
    }
  }
  /**
   * Check for header name existence
   *
   * @param   String   name  Header name
   * @return  Boolean
   */
  ;

  _proto.has = function has(name) {
    name = `${name}`;
    validateName(name);
    return find(this[MAP], name) !== undefined;
  }
  /**
   * Delete all header values given name
   *
   * @param   String  name  Header name
   * @return  Void
   */
  ;

  _proto.delete = function _delete(name) {
    name = `${name}`;
    validateName(name);
    var key = find(this[MAP], name);

    if (key !== undefined) {
      delete this[MAP][key];
    }
  };

  /**
   * Return raw headers (non-spec api)
   *
   * @return  Object
   */
  _proto.raw = function raw() {
    return this[MAP];
  }
  /**
   * Get an iterator on keys.
   *
   * @return  Iterator
   */
  ;

  _proto.keys = function keys() {
    return createHeadersIterator(this, 'key');
  }
  /**
   * Get an iterator on values.
   *
   * @return  Iterator
   */
  ;

  _proto.values = function values() {
    return createHeadersIterator(this, 'value');
  }
  /**
   * Get an iterator on entries.
   *
   * This is the default iterator of the Headers object.
   *
   * @return  Iterator
   */
  ;

  _proto[Symbol.iterator] = function () {
    return createHeadersIterator(this, 'key+value');
  };

  return Headers;
}();
Headers.prototype.entries = Headers.prototype[Symbol.iterator];
Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
  value: 'Headers',
  writable: false,
  enumerable: false,
  configurable: true
});
Object.defineProperties(Headers.prototype, {
  get: {
    enumerable: true
  },
  forEach: {
    enumerable: true
  },
  set: {
    enumerable: true
  },
  append: {
    enumerable: true
  },
  has: {
    enumerable: true
  },
  delete: {
    enumerable: true
  },
  keys: {
    enumerable: true
  },
  values: {
    enumerable: true
  },
  entries: {
    enumerable: true
  }
});

function getHeaders(headers, kind) {
  if (kind === void 0) {
    kind = 'key+value';
  }

  var keys = Object.keys(headers[MAP]).sort();
  return keys.map(kind === 'key' ? function (k) {
    return k.toLowerCase();
  } : kind === 'value' ? function (k) {
    return headers[MAP][k].join(', ');
  } : function (k) {
    return [k.toLowerCase(), headers[MAP][k].join(', ')];
  });
}

var INTERNAL = Symbol('internal');

function createHeadersIterator(target, kind) {
  var iterator = Object.create(HeadersIteratorPrototype);
  iterator[INTERNAL] = {
    target,
    kind,
    index: 0
  };
  return iterator;
}

var HeadersIteratorPrototype = Object.setPrototypeOf({
  next() {
    // istanbul ignore if
    if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
      throw new TypeError('Value of `this` is not a HeadersIterator');
    }

    var _this$INTERNAL = this[INTERNAL],
        target = _this$INTERNAL.target,
        kind = _this$INTERNAL.kind,
        index = _this$INTERNAL.index;
    var values = getHeaders(target, kind);
    var len = values.length;

    if (index >= len) {
      return {
        value: undefined,
        done: true
      };
    }

    this[INTERNAL].index = index + 1;
    return {
      value: values[index],
      done: false
    };
  }

}, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
  value: 'HeadersIterator',
  writable: false,
  enumerable: false,
  configurable: true
});
/**
 * Export the Headers object in a form that Node.js can consume.
 *
 * @param   Headers  headers
 * @return  Object
 */

function exportNodeCompatibleHeaders(headers) {
  var obj = Object.assign({
    __proto__: null
  }, headers[MAP]); // http.request() only supports string as Host header. This hack makes
  // specifying custom Host header possible.

  var hostHeaderKey = find(headers[MAP], 'Host');

  if (hostHeaderKey !== undefined) {
    obj[hostHeaderKey] = obj[hostHeaderKey][0];
  }

  return obj;
}
/**
 * Create a Headers object from an object of headers, ignoring those that do
 * not conform to HTTP grammar productions.
 *
 * @param   Object  obj  Object of headers
 * @return  Headers
 */

function createHeadersLenient(obj) {
  var headers = new Headers();

  for (var _i4 = 0, _Object$keys2 = Object.keys(obj); _i4 < _Object$keys2.length; _i4++) {
    var name = _Object$keys2[_i4];

    if (invalidTokenRegex.test(name)) {
      continue;
    }

    if (Array.isArray(obj[name])) {
      for (var _iterator3 = _createForOfIteratorHelperLoose$1(obj[name]), _step3; !(_step3 = _iterator3()).done;) {
        var val = _step3.value;

        if (invalidHeaderCharRegex.test(val)) {
          continue;
        }

        if (headers[MAP][name] === undefined) {
          headers[MAP][name] = [val];
        } else {
          headers[MAP][name].push(val);
        }
      }
    } else if (!invalidHeaderCharRegex.test(obj[name])) {
      headers[MAP][name] = [obj[name]];
    }
  }

  return headers;
}

var INTERNALS$1 = Symbol('Response internals'); // fix an issue where "STATUS_CODES" aren't a named export for node <10

var STATUS_CODES = http.STATUS_CODES;
/**
 * Response class
 *
 * @param   Stream  body  Readable stream
 * @param   Object  opts  Response options
 * @return  Void
 */

var Response = /*#__PURE__*/function () {
  function Response(body, opts) {
    if (body === void 0) {
      body = null;
    }

    if (opts === void 0) {
      opts = {};
    }

    Body.call(this, body, opts);
    var status = opts.status || 200;
    var headers = new Headers(opts.headers);

    if (body != null && !headers.has('Content-Type')) {
      var contentType = extractContentType(body);

      if (contentType) {
        headers.append('Content-Type', contentType);
      }
    }

    this[INTERNALS$1] = {
      url: opts.url,
      status,
      statusText: opts.statusText || STATUS_CODES[status],
      headers,
      counter: opts.counter
    };
  }

  var _proto = Response.prototype;

  /**
   * Clone this response
   *
   * @return  Response
   */
  _proto.clone = function clone$$1() {
    return new Response(clone(this), {
      url: this.url,
      status: this.status,
      statusText: this.statusText,
      headers: this.headers,
      ok: this.ok,
      redirected: this.redirected
    });
  };

  _createClass(Response, [{
    key: "url",
    get: function get() {
      return this[INTERNALS$1].url || '';
    }
  }, {
    key: "status",
    get: function get() {
      return this[INTERNALS$1].status;
    }
    /**
     * Convenience property representing if the request ended normally
     */

  }, {
    key: "ok",
    get: function get() {
      return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
    }
  }, {
    key: "redirected",
    get: function get() {
      return this[INTERNALS$1].counter > 0;
    }
  }, {
    key: "statusText",
    get: function get() {
      return this[INTERNALS$1].statusText;
    }
  }, {
    key: "headers",
    get: function get() {
      return this[INTERNALS$1].headers;
    }
  }]);

  return Response;
}();
Body.mixIn(Response.prototype);
Object.defineProperties(Response.prototype, {
  url: {
    enumerable: true
  },
  status: {
    enumerable: true
  },
  ok: {
    enumerable: true
  },
  redirected: {
    enumerable: true
  },
  statusText: {
    enumerable: true
  },
  headers: {
    enumerable: true
  },
  clone: {
    enumerable: true
  }
});
Object.defineProperty(Response.prototype, Symbol.toStringTag, {
  value: 'Response',
  writable: false,
  enumerable: false,
  configurable: true
});

var pjson = require('../package.json');

var session = electron.remote.session.defaultSession;
var trackEvent = electron.remote.getGlobal('trackEvent');

var debug = require('debug')('ziti');

var SIXTY = 60;
var TTL = SIXTY * SIXTY; // one hour

var memoryCache = cacheManager.caching({
  store: 'memory',
  max: SIXTY,
  ttl: TTL
});
var mutex = new asyncMutex.Mutex();
var INTERNALS$2 = Symbol('Request internals'); // fix an issue where "format", "parse" aren't a named export for node <10

var parse_url = Url.parse;
var format_url = Url.format;
var streamDestructionSupported = ('destroy' in Stream__default.Readable.prototype);
/**
 * Get path to identity file
 *
 * @return  full path to identity file
 */

function getIdentityFilePath() {
  var identityFilePath = path.join(electron.remote.app.getPath('userData'), 'ziti-identity.json');
  log.debug('identityFilePath is: ' + identityFilePath);
  return identityFilePath;
}
/**
 * Get path to JWT file
 *
 * @return  full path to JWT file
 */


function getJWTFilePath() {
  var jwtFilePath = path.join(electron.remote.app.getPath('userData'), 'ziti-jwt');
  log.debug('jwtFilePath is: ' + jwtFilePath);
  return jwtFilePath;
}
/**
 * Perform Ziti enrollment (connect with Ziti Controller)
 *
 * @return  Promise
 */


function ziti_enroll() {
  return _ziti_enroll.apply(this, arguments);
}

function _ziti_enroll() {
  _ziti_enroll = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", new Promise(function (resolve, reject) {
              log.debug('ziti_enroll entered');
              var identityPath = getJWTFilePath();

              if (!identityPath || identityPath === '') {
                log.debug('identityPath unset: ' + identityPath);
                electron.ipcRenderer.sendToHost('did-fail-load', {
                  zitiIdentityPath: window.zitiIdentityPath,
                  errorDescription: 'Ziti init failed, zitiIdentityPath not set',
                  errorCode: -601
                });
                reject(new Error('Ziti init failed, window.zitiIdentityPath not set'));
              }

              log.debug('Now calling window.ziti.ziti_enroll: ' + window.ziti.ziti_enroll);
              var erc = window.ziti.ziti_enroll(identityPath, function (data) {
                log.debug('window.ziti.ziti_enroll callback entered, data is (%o)', data);

                if (!data.identity) {
                  electron.ipcRenderer.sendToHost('did-fail-load', {
                    zitiIdentityPath: window.zitiIdentityPath,
                    errorDescription: 'Ziti enroll failed rc [' + data.len + '], ' + data.err,
                    errorCode: -602
                  });
                  reject(new Error('Ziti enroll failed rc [' + data.len + '], JWT is invalid'));
                } else {
                  fs.writeFileSync(getIdentityFilePath(), data.identity);
                  resolve();
                }
              });
              log.debug('window.ziti.ziti_enroll rc is (%o)', erc);

              if (erc < 0) {
                if (erc == -2) {
                  electron.ipcRenderer.sendToHost('did-fail-load', {
                    zitiIdentityPath: window.zitiIdentityPath,
                    errorDescription: 'Ziti enroll failed rc [' + erc + '], JWT cannot be found',
                    errorCode: -603
                  });
                } else {
                  electron.ipcRenderer.sendToHost('did-fail-load', {
                    zitiIdentityPath: window.zitiIdentityPath,
                    errorDescription: 'Ziti enroll failed rc [' + erc + '], JWT is invalid',
                    errorCode: -604
                  });
                }

                reject(new Error('Ziti enroll failed rc [' + erc + '], JWT is invalid'));
              }
            }));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _ziti_enroll.apply(this, arguments);
}
/**
 * Perform Ziti initialization (connect with Ziti Controller)
 *
 * @return  Promise
 */

function ziti_init() {
  return _ziti_init.apply(this, arguments);
}

function _ziti_init() {
  _ziti_init = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", new Promise( /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(resolve, reject) {
                var rc;
                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        log.debug('ziti_init entered');

                        if (window.zitiInitialized) {
                          resolve(); // quick exit, init already done
                        } // If we do not have an identity file yet


                        if (fs.existsSync(getIdentityFilePath())) {
                          _context3.next = 5;
                          break;
                        }

                        _context3.next = 5;
                        return ziti_enroll().catch(function (e) {
                          // ipcRenderer.sendToHost('did-fail-load', {zitiIdentityPath: window.zitiIdentityPath, errorDescription: 'Ziti init failed rc [' + rc + '], identity is invalid', errorCode: -703});
                          reject(new Error('Ziti init failed rc [' + err + ']'));
                        });

                      case 5:
                        // let identityPath = window.zitiIdentityPath;	// This is assumed to be set by the app that is hosting us (e.g. Mattermost's MattermostView.jsx)
                        // if (!identityPath || identityPath==='') {
                        // 	debug('identityPath unset (%o)', identityPath);
                        // 	ipcRenderer.sendToHost('did-fail-load', {zitiIdentityPath: window.zitiIdentityPath, errorDescription: 'Ziti init failed, zitiIdentityPath not set', errorCode: -601});
                        // 	reject(new Error('Ziti init failed, window.zitiIdentityPath not set'));
                        // }
                        rc = window.ziti.ziti_init(getIdentityFilePath(), function (cbRC) {
                          log.debug('window.ziti.ziti_init callback entered, cbRC is (%o)', cbRC);

                          if (cbRC < 0) {
                            if (typeof window.zitiInitializedTime === 'undefined') {
                              electron.ipcRenderer.sendToHost('did-fail-load', {
                                zitiIdentityPath: window.zitiIdentityPath,
                                errorDescription: 'Ziti init failed rc [' + cbRC + '], identity is invalid',
                                errorCode: -702
                              });
                            }

                            reject(new Error('Ziti init failed rc [' + cbRC + '], identity is invalid'));
                          } else {
                            resolve();
                          }
                        });
                        log.debug('window.ziti.ziti_init rc is (%o)', rc);

                        if (rc < 0) {
                          electron.ipcRenderer.sendToHost('did-fail-load', {
                            zitiIdentityPath: window.zitiIdentityPath,
                            errorDescription: 'Ziti init failed rc [' + rc + '], identity is invalid',
                            errorCode: -703
                          });
                          reject(new Error('Ziti init failed rc [' + rc + '], identity is invalid'));
                        }

                      case 8:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x4, _x5) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _ziti_init.apply(this, arguments);
}
/**
 * Perform a synchronous, mutex-protected, Ziti initialization. 
 * We only want to initialize once, so we protect the call to the 
 * Ziti Controller behind a mutex.
 *
 * @return  Boolean
 */

function doZitiInitialization() {
  return _doZitiInitialization.apply(this, arguments);
}
/**
 * Do an asynchronous wait for Ziti initialization to complete.
 *
 * @return  Promise
 */


function _doZitiInitialization() {
  _doZitiInitialization = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
    var release, now, elapsed, elapsedSeconds, initFailed;
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return mutex.acquire();

          case 2:
            release = _context5.sent;
            _context5.prev = 3;

            if (window.zitiInitialized) {
              _context5.next = 19;
              break;
            }

            if (!(typeof window.zitiInitializeFailedTime !== 'undefined')) {
              _context5.next = 14;
              break;
            }

            now = new Date();
            elapsed = now - window.zitiInitializeFailedTime;
            elapsedSeconds = Math.round(elapsed /= 1000);
            log.error('doZitiInitialization(): elapsedSeconds since last ziti_init failure: %d', elapsedSeconds);

            if (!(elapsedSeconds < 10)) {
              _context5.next = 13;
              break;
            }

            log.error('doZitiInitialization(): bypassing ziti_init');
            return _context5.abrupt("return");

          case 13:
            window.zitiInitializeFailedTime = undefined;

          case 14:
            initFailed = false;
            log.info('doZitiInitialization(): proceeding with ziti_init');
            _context5.next = 18;
            return ziti_init().catch(function (e) {
              log.error('doZitiInitialization(): ziti_init exception: ' + e);
              initFailed = true;
              window.zitiInitializeFailedTime = new Date();
            });

          case 18:
            if (!initFailed) {
              log.error('doZitiInitialization(): marking window.zitiInitialized = true');
              window.zitiInitialized = true;
              window.zitiInitializedTime = new Date();
            }

          case 19:
            _context5.prev = 19;
            release();
            return _context5.finish(19);

          case 22:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[3,, 19, 22]]);
  }));
  return _doZitiInitialization.apply(this, arguments);
}

function isZitiInitialized() {
  return new Promise(function (resolve, reject) {
    var ctr = 0;

    (function waitForZitiInitialized() {
      if (window.zitiInitialized) {
        return resolve();
      }

      ctr++;

      if (ctr >= 1000) {
        log.error('isZitiInitialized(): wait exceeded');
        return reject();
      }

      setTimeout(waitForZitiInitialized, 100);
    })();
  });
}
/**
 * Ask Ziti Controller if the named service is active in the Ziti network.
 *
 * @param   String   service
 * @return  Promise
 */


function callNativeNFServiceAvailable(service) {
  return new Promise(function (resolve) {
    window.ziti.ziti_service_available(service, function (status) {
      // eslint-disable-line new-cap
      resolve(status);
    });
  });
}
/**
 * Determine if the named service is active in the Ziti network. We check our cache first, which is backed
 * by an asynchronous call to the Ziti Controller.
 *
 * @param   String   service
 * @return  Promise
 */


function getCachedServiceAvailable(service) {
  return new Promise(function (resolve, reject) {
    memoryCache.get(service, /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(err, cachedResult) {
        var newResult;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (err) {
                  reject(err);
                }

                if (!cachedResult) {
                  _context.next = 5;
                  break;
                }

                resolve(cachedResult);
                _context.next = 10;
                break;

              case 5:
                _context.next = 7;
                return callNativeNFServiceAvailable(service).catch(function (e) {
                  return log.error('callNativeNFServiceAvailable Error: ', e.message);
                });

              case 7:
                newResult = _context.sent;
                memoryCache.set(service, newResult);
                resolve(newResult);

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  });
}
/**
 * Check if a value is an instance of Request.
 *
 * @param   Mixed   input
 * @return  Boolean
 */


function isRequest(input) {
  return typeof input === 'object' && typeof input[INTERNALS$2] === 'object';
}

function isAbortSignal(signal) {
  var proto = signal && typeof signal === 'object' && Object.getPrototypeOf(signal);
  return !!(proto && proto.constructor.name === 'AbortSignal');
}
/**
 * Request class
 *
 * @param   Mixed   input  Url or Request instance
 * @param   Object  init   Custom options
 * @return  Void
 */


var Request = /*#__PURE__*/function () {
  function Request(input, init, sessionCookies) {
    if (init === void 0) {
      init = {};
    }

    var parsedURL; // normalize input

    if (!isRequest(input)) {
      if (input && input.href) {
        // in order to support Node.js' Url objects; though WHATWG's URL objects
        // will fall into this branch also (since their `toString()` will return
        // `href` property anyway)
        parsedURL = parse_url(input.href);
      } else {
        // coerce input to a string before attempting to parse
        parsedURL = parse_url(`${input}`);
      }

      input = {};
    } else {
      parsedURL = parse_url(input.url);
    }

    var method = init.method || input.method || 'GET';
    method = method.toUpperCase();

    if ((init.body != null || isRequest(input) && input.body !== null) && (method === 'GET' || method === 'HEAD')) {
      // if (init.body === '') {
      // init.body = undefined;
      // } else {
      throw new TypeError('Request with GET/HEAD method cannot have body'); // }
    }

    var inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;
    Body.call(this, inputBody, {
      timeout: init.timeout || input.timeout || 0,
      size: init.size || input.size || 0
    });
    var headers = new Headers(init.headers || input.headers || {});

    if (inputBody != null && !headers.has('Content-Type')) {
      var contentType = extractContentType(inputBody);

      if (contentType) {
        headers.append('Content-Type', contentType);
      }
    }

    var signal = isRequest(input) ? input.signal : null;
    if ('signal' in init) signal = init.signal;

    if (signal != null && !isAbortSignal(signal)) {
      throw new TypeError('Expected signal to be an instanceof AbortSignal');
    }

    this[INTERNALS$2] = {
      method,
      redirect: init.redirect || input.redirect || 'follow',
      headers,
      parsedURL,
      signal,
      hasActiveZitiService: false
    }; // node-fetch-only options

    this.follow = init.follow !== undefined ? init.follow : input.follow !== undefined ? input.follow : 20;
    this.compress = init.compress !== undefined ? init.compress : input.compress !== undefined ? input.compress : true;
    this.counter = init.counter || input.counter || 0;
    this.agent = init.agent || input.agent;
    this.sessionCookies = sessionCookies;
  }

  var _proto = Request.prototype;

  /**
   * Clone this request
   *
   * @return  Request
   */
  _proto.clone = function clone$$1() {
    return new Request(this);
  };

  _createClass(Request, [{
    key: "method",
    get: function get() {
      return this[INTERNALS$2].method;
    }
  }, {
    key: "url",
    get: function get() {
      return format_url(this[INTERNALS$2].parsedURL);
    }
  }, {
    key: "headers",
    get: function get() {
      return this[INTERNALS$2].headers;
    }
  }, {
    key: "redirect",
    get: function get() {
      return this[INTERNALS$2].redirect;
    }
  }, {
    key: "signal",
    get: function get() {
      return this[INTERNALS$2].signal;
    }
  }, {
    key: "hasActiveZitiService",
    get: function get() {
      return this[INTERNALS$2].hasActiveZitiService;
    }
  }]);

  return Request;
}();
Body.mixIn(Request.prototype);
Object.defineProperty(Request.prototype, Symbol.toStringTag, {
  value: 'Request',
  writable: false,
  enumerable: false,
  configurable: true
});
Object.defineProperties(Request.prototype, {
  method: {
    enumerable: true
  },
  url: {
    enumerable: true
  },
  headers: {
    enumerable: true
  },
  redirect: {
    enumerable: true
  },
  clone: {
    enumerable: true
  },
  signal: {
    enumerable: true
  }
});
/**
 * Load all cookies from Electron persistent storage into memory.
 *
 * @param   Request  A Request instance
 * @param   Domain   A cookie domain
 * @return  Promise
 */

var loadCookies = function loadCookies(request, domain) {
  return new Promise(function (resolve, reject) {
    session.cookies.get({
      domain
    }).then(function (cookies) {
      cookies.forEach(function (cookie) {
        request.sessionCookies.put(cookie);
      });
      resolve();
    }).catch(function (error) {
      reject(error);
    });
  });
};
/**
 * Convert a Request to Node.js http request options.
 *
 * @param   Request  A Request instance
 * @return  Object   The options object to be passed to http.request
 */


function getNodeRequestOptions(_x3) {
  return _getNodeRequestOptions.apply(this, arguments);
}

function _getNodeRequestOptions() {
  _getNodeRequestOptions = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6(request) {
    var parsedURL, headers, key, cookie, _key, _cookie, contentLengthValue, totalBytes, agent, serviceIsAvailable;

    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            parsedURL = request[INTERNALS$2].parsedURL;
            headers = new Headers(request[INTERNALS$2].headers);

            if (!request.sessionCookies.isEmpty()) {
              _context6.next = 5;
              break;
            }

            _context6.next = 5;
            return loadCookies(request, parsedURL.hostname);

          case 5:
            _context6.t0 = _regeneratorRuntime.keys(request.sessionCookies.getAll());

          case 6:
            if ((_context6.t1 = _context6.t0()).done) {
              _context6.next = 18;
              break;
            }

            key = _context6.t1.value;

            if (request.sessionCookies.hasOwnProperty(key)) {
              _context6.next = 10;
              break;
            }

            return _context6.abrupt("continue", 6);

          case 10:
            cookie = request.sessionCookies.get(key); // log.info('request.sessionCookies for: [%s] yields: [%s][%s]', key, cookie.name);

            if (cookie) {
              _context6.next = 13;
              break;
            }

            return _context6.abrupt("continue", 6);

          case 13:
            if (cookie.domain) {
              _context6.next = 15;
              break;
            }

            return _context6.abrupt("continue", 6);

          case 15:
            if (cookie.domain === parsedURL.hostname || cookie.domain === '.' + parsedURL.hostname) {
              // log.info('headers.append: [Cookie: %s=%s]', cookie.name, cookie.value);
              headers.append('Cookie', cookie.name + '=' + cookie.value);

              if (cookie.name === 'MMAUTHTOKEN') {
                headers.append('Authorization', 'Bearer ' + cookie.value);
              }

              if (cookie.name === 'MMCSRF') {
                headers.append('X-Csrf-Token', cookie.value);
              }
            }

            _context6.next = 6;
            break;

          case 18:
            // fetch step 1.3
            if (!headers.has('Accept')) {
              headers.set('Accept', '*/*');
            } // Basic fetch


            if (!parsedURL.hostname) {
              log.info('non-absolute URL encountered, path: %o', parsedURL.path);

              if (ZitiFetchLocation.location !== undefined) {
                parsedURL.hostname = ZitiFetchLocation.location.host;
              }
            }

            if (!parsedURL.protocol) {
              parsedURL.protocol = 'https:';
            }

            if (/^https?:$/.test(parsedURL.protocol)) {
              _context6.next = 23;
              break;
            }

            throw new TypeError('Only HTTP(S) protocols are supported');

          case 23:
            _context6.t2 = _regeneratorRuntime.keys(request.sessionCookies.getAll());

          case 24:
            if ((_context6.t3 = _context6.t2()).done) {
              _context6.next = 35;
              break;
            }

            _key = _context6.t3.value;

            if (request.sessionCookies.hasOwnProperty(_key)) {
              _context6.next = 28;
              break;
            }

            return _context6.abrupt("continue", 24);

          case 28:
            _cookie = request.sessionCookies.get(_key);

            if (_cookie) {
              _context6.next = 31;
              break;
            }

            return _context6.abrupt("continue", 24);

          case 31:
            if (_cookie.domain) {
              _context6.next = 33;
              break;
            }

            return _context6.abrupt("continue", 24);

          case 33:
            _context6.next = 24;
            break;

          case 35:
            if (!(request.signal && request.body instanceof Stream__default.Readable && !streamDestructionSupported)) {
              _context6.next = 37;
              break;
            }

            throw new Error('Cancellation of streamed requests with AbortSignal is not supported in node < 8');

          case 37:
            // HTTP-network-or-cache fetch steps 2.4-2.7
            contentLengthValue = null;

            if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
              contentLengthValue = '0';
            }

            if (request.body != null) {
              totalBytes = getTotalBytes(request);

              if (typeof totalBytes === 'number') {
                contentLengthValue = String(totalBytes);
              }
            }

            if (/^(POST|PUT)$/i.test(request.method)) {
              if (typeof contentLengthValue == 'string') {
                headers.set('Content-Length', contentLengthValue); // headers.set('Transfer-Encoding', 'chunked');
              } else {
                // it must be a stream, so we go with chunked encoding instead of content length
                headers.set('Transfer-Encoding', 'chunked');
              }
            } // HTTP-network-or-cache fetch step 2.11


            if (!headers.has('User-Agent')) {
              headers.set('User-Agent', 'ziti-electron-fetch/' + pjson.version);
            } // --- Disable gzip for now ---
            //
            // // HTTP-network-or-cache fetch step 2.15
            // if (request.compress && !headers.has('Accept-Encoding')) {
            // 	headers.set('Accept-Encoding', 'gzip,deflate');
            // }


            agent = request.agent;

            if (typeof agent === 'function') {
              agent = agent(parsedURL);
            }

            doZitiInitialization();
            _context6.next = 47;
            return isZitiInitialized().catch(function (e) {
              throw new TypeError('Ziti Initialization Failed');
            });

          case 47:
            if (!(parsedURL.host && parsedURL.host)) {
              _context6.next = 52;
              break;
            }

            _context6.next = 50;
            return getCachedServiceAvailable(parsedURL.host).catch(function (e) {
              return log.error('getCachedServiceAvailable Error: ', e.message);
            });

          case 50:
            serviceIsAvailable = _context6.sent;

            // eslint-disable-line new-cap
            if (serviceIsAvailable) {
              if (serviceIsAvailable.status === 0) {
                request[INTERNALS$2].hasActiveZitiService = true;
              } else {
                request[INTERNALS$2].hasActiveZitiService = false;
              }
            } else {
              request[INTERNALS$2].hasActiveZitiService = false;
            }

          case 52:
            if (!headers.has('Connection') && !agent) {
              headers.set('Connection', 'keep-alive');
            } // HTTP-network fetch step 4.2
            // chunked encoding is handled by Node.js


            return _context6.abrupt("return", Object.assign({}, parsedURL, {
              method: request.method,
              headers: exportNodeCompatibleHeaders(headers),
              agent
            }));

          case 54:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _getNodeRequestOptions.apply(this, arguments);
}

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var FetchLocation = /*#__PURE__*/function () {
  function FetchLocation(location) {
    if (location === void 0) {
      location = undefined;
    }

    this._location = location;
  }

  _createClass(FetchLocation, [{
    key: "location",
    get: function get() {
      return this._location;
    },
    set: function set(location) {
      this._location = location;
    }
  }]);

  return FetchLocation;
}();

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * Create AbortError instance
 *
 * @param   String      message      Error message for human
 * @return  AbortError
 */
function AbortError(message) {
  Error.call(this, message);
  this.type = 'aborted';
  this.message = message; // hide custom error implementation details from end-users

  Error.captureStackTrace(this, this.constructor);
}
AbortError.prototype = Object.create(Error.prototype);
AbortError.prototype.constructor = AbortError;
AbortError.prototype.name = 'AbortError';

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var SESSION_COOKIES = Symbol('Session cookies');

var SessionCookies = /*#__PURE__*/function () {
  function SessionCookies() {
    this[SESSION_COOKIES] = {};
  }

  var _proto = SessionCookies.prototype;

  _proto.put = function put(cookie) {
    this[SESSION_COOKIES][cookie.name] = cookie;
  };

  _proto.getValue = function getValue(cookie) {
    return this[SESSION_COOKIES][cookie.name].value;
  };

  _proto.delete = function _delete(cookie) {
    this[SESSION_COOKIES][cookie.name] = null;
  };

  _proto.getAll = function getAll() {
    return this[SESSION_COOKIES];
  };

  _proto.get = function get(key) {
    return this[SESSION_COOKIES][key];
  };

  _proto.hasOwnProperty = function hasOwnProperty(key) {
    return this[SESSION_COOKIES].hasOwnProperty(key);
  };

  _proto.isEmpty = function isEmpty() {
    for (var key in this[SESSION_COOKIES]) {
      if (this[SESSION_COOKIES].hasOwnProperty(key)) {
        return false;
      }
    }

    return true;
  };

  _proto.toString = function toString() {
    return '[object SessionCookies]';
  };

  return SessionCookies;
}();
Object.defineProperties(SessionCookies.prototype, {
  size: {
    enumerable: true
  },
  type: {
    enumerable: true
  },
  slice: {
    enumerable: true
  }
});
Object.defineProperty(SessionCookies.prototype, Symbol.toStringTag, {
  value: 'SessionCookies',
  writable: false,
  enumerable: false,
  configurable: true
});

var XMLHttpRequest$1 = XMLHttpRequest = function XMLHttpRequest() {
  /**
   * Private variables
   */

  var self = this; // Holds http.js objects

  var request;
  var response; // Request settings

  var settings = {};
  var headers = {};
  var headersCase = {}; // These headers are not user setable.
  // The following are allowed but banned in the spec:
  // * user-agent

  var forbiddenRequestHeaders = ["accept-charset", "accept-encoding", "access-control-request-headers", "access-control-request-method", "connection", "content-length", "content-transfer-encoding", "cookie", "cookie2", "date", "expect", "host", "keep-alive", "origin", "referer", "te", "trailer", "transfer-encoding", "upgrade", "via"]; // These request methods are not allowed

  var forbiddenRequestMethods = ["TRACE", "TRACK", "CONNECT"]; // Send flag

  var sendFlag = false; // Error flag, used when errors occur or abort is called

  var errorFlag = false; // Event listeners

  var listeners = {};
  /**
   * Constants
   */

  this.UNSENT = 0;
  this.OPENED = 1;
  this.HEADERS_RECEIVED = 2;
  this.LOADING = 3;
  this.DONE = 4;
  /**
   * Public vars
   */
  // Current state

  this.readyState = this.UNSENT; // default ready state change handler in case one is not set or is set late

  this.onreadystatechange = null; // Result & response

  this.responseBodyText = "";
  this.responseXML = "";
  this.status = null;
  this.statusText = null; // Whether cross-site Access-Control requests should be made using
  // credentials such as cookies or authorization headers

  this.withCredentials = false;
  /**
   * Private methods
   */

  /**
   * Check if the specified header is allowed.
   *
   * @param string header Header to validate
   * @return boolean False if not allowed, otherwise true
   */

  var isAllowedHttpHeader = function isAllowedHttpHeader(header) {
    return header && forbiddenRequestHeaders.indexOf(header.toLowerCase()) === -1;
  };
  /**
   * Check if the specified method is allowed.
   *
   * @param string method Request method to validate
   * @return boolean False if not allowed, otherwise true
   */


  var isAllowedHttpMethod = function isAllowedHttpMethod(method) {
    return method && forbiddenRequestMethods.indexOf(method) === -1;
  };
  /**
   * Public methods
   */

  /**
   * Open the connection. Currently supports local server requests.
   *
   * @param string method Connection method (eg GET, POST)
   * @param string url URL for the connection.
   * @param boolean async Asynchronous connection. Default is true.
   * @param string user Username for basic authentication (optional)
   * @param string password Password for basic authentication (optional)
   */


  this.open = function (method, url, async, user, password) {
    // log.info('XHR.open() method: %o, url: %o, async: %o', method, url, async);
    this.abort();
    errorFlag = false; // Check for valid request method

    if (!isAllowedHttpMethod(method)) {
      throw new Error("SecurityError: Request method not allowed");
    }

    settings = {
      "method": method,
      "url": url.toString(),
      "async": typeof async !== "boolean" ? true : async,
      "user": user || null,
      "password": password || null
    };
    setState(this.OPENED);
  };
  /**
   * Sets a header for the request or appends the value if one is already set.
   *
   * @param string header Header name
   * @param string value Header value
   */


  this.setRequestHeader = function (header, value) {
    if (this.readyState !== this.OPENED) {
      throw new Error("INVALID_STATE_ERR: setRequestHeader can only be called when state is OPEN");
    }

    if (!isAllowedHttpHeader(header)) {
      console.warn("Refused to set unsafe header \"" + header + "\"");
      return;
    }

    if (sendFlag) {
      throw new Error("INVALID_STATE_ERR: send flag is true");
    }

    header = headersCase[header.toLowerCase()] || header;
    headersCase[header.toLowerCase()] = header;
    headers[header] = headers[header] ? headers[header] + ', ' + value : value;
  };
  /**
   * Gets a header from the server response.
   *
   * @param string header Name of header to get.
   * @return string Text of the header or null if it doesn't exist.
   */


  this.getResponseHeader = function (header) {
    if (typeof header === "string" && this.readyState > this.OPENED && response && response.headers && !errorFlag) {
      var _headers = response.headers.raw();

      for (var h in _headers) {
        if (header.toLowerCase() === h.toLowerCase()) {
          var headerValue = _headers[h][0];
          return headerValue.toLowerCase();
        }
      }

      return null;
    }

    return null;
  };
  /**
   * Gets all the response headers.
   *
   * @return string A string with all response headers separated by CR+LF
   */


  this.getAllResponseHeaders = function () {
    if (this.readyState < this.HEADERS_RECEIVED || errorFlag) {
      return "";
    }

    var headers = response.headers.raw();
    var result = "";

    for (var header in headers) {
      if (header !== "set-cookie" && header !== "set-cookie2") {
        var headerValue = headers[header][0];
        result += header + ": " + headerValue + "\r\n";
      }
    }

    return result.substr(0, result.length - 2);
  };
  /**
   * Gets a request header
   *
   * @param string name Name of header to get
   * @return string Returns the request header or empty string if not set
   */


  this.getRequestHeader = function (name) {
    if (typeof name === "string" && headersCase[name.toLowerCase()]) {
      return headers[headersCase[name.toLowerCase()]];
    }

    return "";
  };
  /**
   * Sends the request to the server.
   *
   * @param string data Optional data to send as request body.
   */


  this.send = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(data) {
      var resp;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(this.readyState !== this.OPENED)) {
                _context.next = 2;
                break;
              }

              throw new Error("INVALID_STATE_ERR: connection must be opened before send() is called");

            case 2:
              if (!sendFlag) {
                _context.next = 4;
                break;
              }

              throw new Error("INVALID_STATE_ERR: send has already been called");

            case 4:
              errorFlag = false;
              sendFlag = true; // As per spec, this is called here for historical reasons.

              self.dispatchEvent("readystatechange");
              self.dispatchEvent("loadstart");
              settings.body = data;
              _context.next = 11;
              return fetch(settings.url, settings);

            case 11:
              resp = _context.sent;
              // log.info('XHR resp: %o', resp);
              // log.info('XHR resp.body.on: %o', resp.body.on);
              response = resp;
              self.status = resp.status;
              response.body.on('data', function (chunk) {
                // log.info('XHR resp on.data: \n%s', chunk);
                self.responseBodyText += chunk;

                if (sendFlag) {
                  setState(self.LOADING);
                }
              });
              response.body.on('end', function (chunk) {
                // log.info('XHR resp on.end: \n%s', chunk);
                self.response = self.responseBodyText;
                sendFlag = false;
                setState(self.DONE);
              });

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
  /**
   * Called when an error is encountered to deal with it.
   */


  this.handleError = function (error) {
    this.status = 0;
    this.statusText = error;
    this.responseText = error.stack;
    errorFlag = true;
    setState(this.DONE);
    this.dispatchEvent('error');
  };
  /**
   * Aborts a request.
   */


  this.abort = function () {
    if (request) {
      request.abort();
      request = null;
    } // headers = defaultHeaders;


    this.status = 0;
    this.responseText = "";
    this.responseXML = "";
    errorFlag = true;

    if (this.readyState !== this.UNSENT && (this.readyState !== this.OPENED || sendFlag) && this.readyState !== this.DONE) {
      sendFlag = false;
      setState(this.DONE);
    }

    this.readyState = this.UNSENT;
    this.dispatchEvent('abort');
  };
  /**
   * Adds an event listener. Preferred method of binding to events.
   */


  this.addEventListener = function (event, callback) {
    if (!(event in listeners)) {
      listeners[event] = [];
    } // Currently allows duplicate callbacks. Should it?


    listeners[event].push(callback);
  };
  /**
   * Remove an event callback that has already been bound.
   * Only works on the matching function, cannot be a copy.
   */


  this.removeEventListener = function (event, callback) {
    if (event in listeners) {
      // Filter will return a new array with the callback removed
      listeners[event] = listeners[event].filter(function (ev) {
        return ev !== callback;
      });
    }
  };
  /**
   * Dispatch any events, including both "on" methods and events attached using addEventListener.
   */


  this.dispatchEvent = function (event) {
    // log.info('XHR.dispatchEvent: [%o]', event);
    if (typeof self["on" + event] === "function") {
      self["on" + event]();
    }

    if (event in listeners) {
      for (var i = 0, len = listeners[event].length; i < len; i++) {
        listeners[event][i].call(self);
      }
    }
  };
  /**
   * Changes readyState and calls onreadystatechange.
   *
   * @param int state New state
   */


  var setState = function setState(state) {
    if (state == self.LOADING || self.readyState !== state) {
      self.readyState = state;

      if (settings.async || self.readyState < self.OPENED || self.readyState === self.DONE) {
        self.dispatchEvent("readystatechange");
      }

      if (self.readyState === self.DONE && !errorFlag) {
        self.dispatchEvent("load"); // @TODO figure out InspectorInstrumentation::didLoadXHR(cookie)

        self.dispatchEvent("loadend");
      }
    }
  };
};

/**
 * Base HTTP "ZitiRequest" class. Emulates the node-core `http.ClientRequest` class, but
 * does not use Socket, and instead integrates with the ziti-sdk-nodejs https_request_XXX
 * mechanisms.
 *
 * @api public
 */

var ZitiResponse = /*#__PURE__*/function (_Duplex) {
  _inheritsLoose(ZitiResponse, _Duplex);

  function ZitiResponse(uuid$$1) {
    var _this;

    _this = _Duplex.call(this) || this;
    _this.uuid = uuid$$1; // debugging/tracing aid

    /**
     * This stream is where we'll put any data returned from a ZitiRequest
     */

    _this.readableZitiStream = new Stream.Readable();

    _this.readableZitiStream._read = function () {}
    /* nop */

    /**
     * Start the async iterator on the stream.
     */
    ;

    setImmediate(_this._pumpZitiStream.bind(_assertThisInitialized(_this))); // setTimeout(()=>this._pumpZitiStream.bind(this),0)

    /**
     *  Properties
     */

    _this._headers;
    _this._statusCode;
    _this._statusMessage;
    return _this;
  }

  var _proto = ZitiResponse.prototype;

  _proto._read = function _read() {}
  /* nop */

  /**
   * Pump all data arriving from ZitiRequest out into the stream represented by this ZitiResponse object
   */
  ;

  _proto._pumpZitiStream =
  /*#__PURE__*/
  function () {
    var _pumpZitiStream2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _this2 = this;

      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _value, chunk;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // logger.info('this._pumpZitiStream() entered: this.uuid is: %o', this.uuid);
              // Block here waiting for a chunk of data
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _context.prev = 2;
              _iterator = _asyncIterator(this.readableZitiStream);

            case 4:
              _context.next = 6;
              return _iterator.next();

            case 6:
              _step = _context.sent;
              _iteratorNormalCompletion = _step.done;
              _context.next = 10;
              return _step.value;

            case 10:
              _value = _context.sent;

              if (_iteratorNormalCompletion) {
                _context.next = 19;
                break;
              }

              chunk = _value;

              if (this.push(chunk)) {
                _context.next = 16;
                break;
              }

              _context.next = 16;
              return new Promise(function (res, rej) {
                // logger.info('this._pumpZitiStream() awaiting drain');
                _this2.once("drain", res);
              });

            case 16:
              _iteratorNormalCompletion = true;
              _context.next = 4;
              break;

            case 19:
              _context.next = 25;
              break;

            case 21:
              _context.prev = 21;
              _context.t0 = _context["catch"](2);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 25:
              _context.prev = 25;
              _context.prev = 26;

              if (!(!_iteratorNormalCompletion && _iterator.return != null)) {
                _context.next = 30;
                break;
              }

              _context.next = 30;
              return _iterator.return();

            case 30:
              _context.prev = 30;

              if (!_didIteratorError) {
                _context.next = 33;
                break;
              }

              throw _iteratorError;

            case 33:
              return _context.finish(30);

            case 34:
              return _context.finish(25);

            case 35:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[2, 21, 25, 35], [26,, 30, 34]]);
    }));

    function _pumpZitiStream() {
      return _pumpZitiStream2.apply(this, arguments);
    }

    return _pumpZitiStream;
  }()
  /**
   * 
   */
  ;

  _proto._pushData =
  /*#__PURE__*/
  function () {
    var _pushData2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(buffer) {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // logger.info('_pushData(): uuid: %o, buf is: %o', this.uuid, buffer);
              if (buffer) {
                this.readableZitiStream.push(buffer);
              } else {
                this.push(null);
              }

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function _pushData(_x) {
      return _pushData2.apply(this, arguments);
    }

    return _pushData;
  }()
  /**
   *  Properties
   */
  ;

  /**
   * 
   */
  _proto.setTimeout = function setTimeout(msecs, callback) {
    if (callback) this.on('timeout', callback);
    return this;
  }
  /**
   * 
   */
  ;

  _proto.destroy = function destroy(error) {};

  _createClass(ZitiResponse, [{
    key: "headers",
    get: function get() {
      return this._headers;
    },
    set: function set(headers) {
      this._headers = headers;
    }
  }, {
    key: "statusCode",
    get: function get() {
      return this._statusCode;
    },
    set: function set(statusCode) {
      this._statusCode = statusCode;
    }
  }, {
    key: "statusMessage",
    get: function get() {
      return this._statusMessage;
    },
    set: function set(statusMessage) {
      this._statusMessage = statusMessage;
    }
  }]);

  return ZitiResponse;
}(Stream.Duplex);

var UV_EOF = -4095;
/**
 * Base HTTP "ZitiRequest" class. Emulates the node-core `http.ClientRequest` class, but
 * does not use Socket, and instead integrates with the ziti-sdk-nodejs https_request_XXX
 * mechanisms.
 *
 * @api public
 */

var ZitiRequest = /*#__PURE__*/function (_EventEmitter) {
  _inheritsLoose(ZitiRequest, _EventEmitter);

  function ZitiRequest(opts) {
    var _this;

    _this = _EventEmitter.call(this) || this;
    _this.uuid = uuid.v4(); // debugging/tracing aid

    /**
     * 
     */

    _this.opts = opts;
    /**
     * The underlying Ziti HTTP Request (i.e. the um_http_req_t returned from Ziti_http_request() in the ziti-sdk-NodeJS )
     */

    _this.ziti_http_request;
    /**
     * This response is where we'll put any data returned from a um_http_req_t
     */

    _this.response = new ZitiResponse(_this.uuid);
    /**
     *  Properties
     */

    _this._writable = true;
    return _this;
  }
  /**
   *  Properties
   */


  var _proto = ZitiRequest.prototype;

  /**
   * Initiate an HTTPS request.  We do this by invoking the Ziti_http_request() function in the Ziti NodeJS-SDK.
   * @param {*} url 
   * @param {*} method 
   * @param {*} headers 
   */
  _proto.do_Ziti_http_request =
  /*#__PURE__*/
  function () {
    var _do_Ziti_http_request = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url, method, headers) {
      var _this2 = this;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", new Promise(function (resolve, reject) {
                try {
                  // logger.info('TRANSMITTING: req uuid: %o \nmethod: %s \nurl: %s \nheaders: %0', this.uuid, method, url, headers);
                  window.ziti.Ziti_http_request(url, method, headers, // on_req callback
                  function (obj) {
                    // logger.info('on_req callback: req is: %o', obj.req);
                    resolve(obj.req);
                  }, // on_resp callback
                  function (obj) {
                    // logger.info('TRANSMITTING (on_resp callback): req uuid: %o \nobj: %0', this.uuid, obj);
                    // Set properties
                    _this2.response.headers = obj.headers;
                    _this2.response.statusCode = obj.code;
                    _this2.response.statusMessageCode = obj.status;
                    log.info('on_resp callback: req is: %o, statusCode: %o', _this2.ziti_http_request, _this2.response.statusCode); // logger.info('on_resp callback: emitting resp: %o', this.response);

                    _this2.emit('response', _this2.response);
                  }, // on_resp_body callback
                  function (obj) {
                    // logger.info('on_resp_body callback: req is: %o, len: %o', this.ziti_http_request, obj.len);
                    //
                    //  REQUEST COMPLETE 
                    //
                    if (obj.len === UV_EOF) {
                      // logger.info('REQUEST COMPLETE');
                      _this2.response._pushData(null);

                      _this2.response.emit('close');
                    } //
                    //  ERROR 
                    //
                    else if (obj.len < 0) {
                        var err = _this2.requestException(obj.len); // logger.error('on_resp_body callback: emitting error: %o', err);


                        _this2.emit('error', err);
                      } //
                      // DATA RECEIVED
                      //
                      else {
                          if (obj.body) {
                            var buffer = Buffer.from(obj.body); // logger.info('on_resp_body callback: DATA RECEIVED: body is: \n%s', buffer.toString());

                            _this2.response._pushData(buffer);
                          }
                        }
                  });
                } catch (e) {
                  reject(e);
                }
              }));

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function do_Ziti_http_request(_x, _x2, _x3) {
      return _do_Ziti_http_request.apply(this, arguments);
    }

    return do_Ziti_http_request;
  }()
  /**
   *  Initiate the HTTPS request
   */
  ;

  _proto.start =
  /*#__PURE__*/
  function () {
    var _start = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var _this3 = this;

      var headersArray, _i, _Object$keys, key, hdr;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              headersArray = [];

              for (_i = 0, _Object$keys = Object.keys(this.opts.headers); _i < _Object$keys.length; _i++) {
                key = _Object$keys[_i];
                hdr = void 0;

                if (key === 'Cookie') {
                  (function () {
                    var value = '';

                    _this3.opts.headers[key].forEach(function (element) {
                      if (value.length > 0) {
                        value += ';';
                      }

                      value += element;
                    });

                    hdr = key + ':' + value;
                  })();
                } else {
                  hdr = key + ':' + this.opts.headers[key];
                }

                headersArray.push(hdr);
              }

              _context2.next = 4;
              return this.do_Ziti_http_request(this.opts.href, this.opts.method, headersArray).catch(function (e) {
                log.error('Error: %o', e);
              });

            case 4:
              this.ziti_http_request = _context2.sent;

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function start() {
      return _start.apply(this, arguments);
    }

    return start;
  }()
  /**
   * 
   */
  ;

  _proto.end = function end(chunk, encoding, callback) {
    // logger.info('req.end() req is: %o', this.ziti_http_request);
    if (typeof this.ziti_http_request !== 'undefined') {
      window.ziti.Ziti_http_request_end(this.ziti_http_request);
    }

    return this;
  };

  /**
   * Send a request body chunk.  We do this by invoking the Ziti_http_request_data() function in the Ziti NodeJS-SDK.
   * @param {*} req 
   * @param {*} buffer 
   */
  _proto.do_Ziti_http_request_data =
  /*#__PURE__*/
  function () {
    var _do_Ziti_http_request_data = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(req, buffer) {
      var _this4 = this;
      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt("return", new Promise(function (resolve, reject) {
                try {
                  // logger.info('do_Ziti_http_request_data() for: req: %o', req);
                  if (typeof req === 'undefined') {
                    log.error('req is "undefined"');
                    throw new Error('req is "undefined"');
                  } // logger.info('SEND request_data for req uuid: %o, data (%o)', this.uuid, buffer);


                  window.ziti.Ziti_http_request_data(req, buffer, // on_req_body callback
                  function (obj) {
                    // logger.info('on_req_body() cb, obj: %o', obj);
                    //
                    //  ERROR 
                    //
                    if (obj.status < 0) {
                      log.error('obj.status === ERROR');
                      reject(_this4.requestException(obj.status));
                    } //
                    // SUCCESSFUL TRANSMISSION
                    //
                    else {
                        // logger.info('DATA TRAMSMITTED for req: %o', req);
                        resolve(obj);
                      }
                  });
                } catch (e) {
                  reject(e);
                }
              }));

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function do_Ziti_http_request_data(_x4, _x5) {
      return _do_Ziti_http_request_data.apply(this, arguments);
    }

    return do_Ziti_http_request_data;
  }()
  /**
   * Send a request body chunk.
   */
  ;

  _proto.write =
  /*#__PURE__*/
  function () {
    var _write = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(chunk, encoding, callback) {
      var _this5 = this;

      var buffer, obj;
      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (!(typeof chunk === 'string' || chunk instanceof String)) {
                _context4.next = 4;
                break;
              }

              buffer = Buffer.from(chunk, 'utf8');
              _context4.next = 9;
              break;

            case 4:
              if (!Buffer.isBuffer(chunk)) {
                _context4.next = 8;
                break;
              }

              buffer = chunk;
              _context4.next = 9;
              break;

            case 8:
              throw new Error('chunk type of [' + typeof chunk + '] is not a supported type');

            case 9:
              _context4.next = 11;
              return this.do_Ziti_http_request_data(this.ziti_http_request, buffer).catch(function (e) {
                log.error('Error: %o', e);

                _this5.emit('error', e);
              });

            case 11:
              obj = _context4.sent;

            case 12:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function write(_x6, _x7, _x8) {
      return _write.apply(this, arguments);
    }

    return write;
  }()
  /**
   * 
   */
  ;

  _proto.requestException = function requestException(num) {
    var ex = new Error('HTTPS Request failed; code [' + num + ']');
    ex.code = 'EREQUEST';
    return ex;
  }
  /**
   * 
   */
  ;

  _proto.abort = function abort() {};

  _createClass(ZitiRequest, [{
    key: "writable",
    get: function get() {
      return this._writable;
    },
    set: function set(writable) {
      this._writable = writable;
    }
  }]);

  return ZitiRequest;
}(events.EventEmitter);

log.info('ziti-electron-fetch LOADED');
var shutdownMutex = new asyncMutex.Mutex();
var ziti;

try {
  log.info('about to load ziti-sdk-nodejs');
  ziti = require('ziti-sdk-nodejs');
  log.info('ziti is: %o', ziti);

  require('assert').equal(ziti.ziti_hello(), "ziti");

  log.info('ziti.ziti_hello says: %s', ziti.ziti_hello());
} catch (e) {
  log.error(e);
}

var session$1 = electron.remote.session.defaultSession;

try {
  window.realFetch = window.fetch;
  window.ziti = ziti;
  window.realFormData = window.FormData;
  window.FormData = FormData;
  window.realXMLHttpRequest = window.XMLHttpRequest;
  window.XMLHttpRequest = XMLHttpRequest$1;
  window.ZitiFetchLocation = new FetchLocation(location);
} catch (e) {
  log.error(e);
  debugger;
}

var SESSION_COOKIES$1 = new SessionCookies(); // fix an issue where "format", "parse" aren't a named export for node <10

var parse_url$1 = Url.parse;
/**
 * Update our cookie cache when Electron informs us of changes.
 *
 */

session$1.cookies.on('changed', function (event, cookie, _
/*cause*/
, removed) {
  if (SESSION_COOKIES$1.get(cookie.name)) {
    if (removed) {
      SESSION_COOKIES$1.delete(cookie);
    } else {
      if (SESSION_COOKIES$1.getValue(cookie) === cookie.value) ; else {
        SESSION_COOKIES$1.put(cookie);
      }
    }
  } else {
    SESSION_COOKIES$1.put(cookie);
  }
});
/**
 * Update our cookie cache when we see set-cookie headers in HTTP responses
 *
 */

function captureCookies(_x, _x2) {
  return _captureCookies.apply(this, arguments);
} // fix an issue where "PassThrough", "resolve" aren't a named export for node <10


function _captureCookies() {
  _captureCookies = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(url, headers) {
    var parsedURL, setCookieHeaders;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            parsedURL = parse_url$1(url);
            setCookieHeaders = headers.raw()['Set-Cookie'];

            if (!setCookieHeaders) {
              _context4.next = 6;
              break;
            }

            setCookieHeaders.forEach( /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(element) {
                var pieces, cookieName, cookieValue, cookieValuePieces, expiration, httpOnlyFlag, cookie;
                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        if (!session$1) {
                          _context3.next = 14;
                          break;
                        }

                        pieces = element.split(/=(.+)/);
                        cookieName = pieces[0];
                        cookieValue = pieces[1];
                        cookieValuePieces = cookieValue.split(/;(.+)/);
                        cookieValue = cookieValuePieces[0];
                        expiration = new Date();
                        expiration.setHours(expiration.getHours() + 24 * 90);
                        httpOnlyFlag = false;

                        if (cookieName === 'MMAUTHTOKEN') {
                          httpOnlyFlag = true;
                        }

                        cookie = {
                          url: parsedURL.protocol + '//' + parsedURL.hostname,
                          name: cookieName,
                          value: cookieValue,
                          domain: parsedURL.hostname,
                          path: '/',
                          secure: true,
                          httpOnly: httpOnlyFlag,
                          expirationDate: expiration.getTime()
                        };
                        SESSION_COOKIES$1.put(cookie);
                        _context3.next = 14;
                        return session$1.cookies.set(cookie).catch(function (e) {
                          return log.error('session.cookies.set() Error: ', e.message);
                        });

                      case 14:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x6) {
                return _ref3.apply(this, arguments);
              };
            }());
            _context4.next = 6;
            return session$1.cookies.flushStore().catch(function (e) {
              return log.error('session.cookies.flushStore() Error: ', e.message);
            });

          case 6:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _captureCookies.apply(this, arguments);
}

var PassThrough$1 = Stream__default.PassThrough;
var resolve_url = Url.resolve;

function fetch$1(url, opts) {
  // log.info('fetch() \nurl: %s \nopts: %o', url, opts);
  // allow custom promise
  if (!fetch$1.Promise) {
    throw new Error('native promise missing, set fetch.Promise to your favorite alternative');
  }

  if (/^data:/.test(url)) {
    var request = new Request(url, opts, SESSION_COOKIES$1);

    try {
      var data = Buffer.from(url.split(',')[1], 'base64');
      var res = new Response(data.body, {
        headers: {
          'Content-Type': data.mimeType || url.match(/^data:(.+);base64,.*$/)[1]
        }
      });
      return fetch$1.Promise.resolve(res);
    } catch (err) {
      return fetch$1.Promise.reject(new FetchError(`[${request.method}] ${request.url} invalid URL, ${err.message}`, 'system', err));
    }
  }

  Body.Promise = fetch$1.Promise; // wrap http.request into fetch

  return new fetch$1.Promise( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(resolve, reject) {
      var request, options, send, signal, response, abort, abortAndFinalize, req, reqTimeout, finalize;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              finalize = function _finalize() {
                req.abort();
                if (signal) signal.removeEventListener('abort', abortAndFinalize);
                clearTimeout(reqTimeout);
              };

              // build request object
              request = new Request(url, opts, SESSION_COOKIES$1);
              _context2.next = 4;
              return getNodeRequestOptions(request);

            case 4:
              options = _context2.sent;
              send = (options.protocol === 'https:' ? https : http).request;
              signal = request.signal;
              response = null;

              abort = function abort() {
                var error = new AbortError('The user aborted a request.');
                reject(error);

                if (request.body && request.body instanceof Stream__default.Readable) {
                  request.body.destroy(error);
                }

                if (!response || !response.body) return;
                response.body.emit('error', error);
              };

              if (!(signal && signal.aborted)) {
                _context2.next = 12;
                break;
              }

              abort();
              return _context2.abrupt("return");

            case 12:
              abortAndFinalize = function abortAndFinalize() {
                abort();
                finalize();
              };

              if (!request.hasActiveZitiService) {
                _context2.next = 27;
                break;
              }

              _context2.prev = 14;
              // log.info('ZITIFYd send \nurl: %s\nheaders: %o', options.href, options.headers);
              req = new ZitiRequest(options);
              _context2.next = 18;
              return req.start();

            case 18:
              _context2.next = 25;
              break;

            case 20:
              _context2.prev = 20;
              _context2.t0 = _context2["catch"](14);
              log.error('err: %o', _context2.t0);
              reject(new FetchError(`request to ${request.url} failed, reason: ${_context2.t0.message}`, 'system', _context2.t0));
              finalize();

            case 25:
              _context2.next = 28;
              break;

            case 27:
              // ... otherwise route over raw internet
              // log.info('BYPASSing: %o', options);
              req = send(options);

            case 28:
              if (signal) {
                signal.addEventListener('abort', abortAndFinalize);
              }

              if (request.timeout) {
                req.once('socket', function (socket) {
                  reqTimeout = setTimeout(function () {
                    reject(new FetchError(`network timeout at: ${request.url}`, 'request-timeout'));
                    finalize();
                  }, request.timeout);
                });
              }

              req.on('error', function (err) {
                log.error('error EVENT: err: %o', err);
                reject(new FetchError(`request to ${request.url} failed, reason: ${err.message}`, 'system', err));
                finalize();
              });
              req.on('response', /*#__PURE__*/function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(res) {
                  var headers, _location, locationURL, requestOpts, body, response_options, codings, zlibOptions, raw;

                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!(res.statusCode < 0)) {
                            _context.next = 5;
                            break;
                          }

                          // Ziti error?
                          log.error('req.on[response] \nrequest.url: %s \nres.statusCode is: %o', request.url, res.statusCode);
                          reject(new FetchError(`Ziti error: [${res.statusCode}] at: ${request.url}`, 'ziti-error'));
                          finalize();
                          return _context.abrupt("return");

                        case 5:
                          clearTimeout(reqTimeout);
                          headers = createHeadersLenient(res.headers);
                          captureCookies(request.url, headers); // HTTP fetch step 5

                          if (!fetch$1.isRedirect(res.statusCode)) {
                            _context.next = 34;
                            break;
                          }

                          // HTTP fetch step 5.2
                          _location = headers.get('Location'); // HTTP fetch step 5.3

                          locationURL = _location === null ? null : resolve_url(request.url, _location); // HTTP fetch step 5.5

                          _context.t0 = request.redirect;
                          _context.next = _context.t0 === 'error' ? 14 : _context.t0 === 'manual' ? 17 : _context.t0 === 'follow' ? 19 : 34;
                          break;

                        case 14:
                          reject(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${request.url}`, 'no-redirect'));
                          finalize();
                          return _context.abrupt("return");

                        case 17:
                          // node-fetch-specific step: make manual redirect a bit easier to use by setting the Location header value to the resolved URL.
                          if (locationURL !== null) {
                            // handle corrupted header
                            try {
                              headers.set('Location', locationURL);
                            } catch (err) {
                              // istanbul ignore next: nodejs server prevent invalid response headers, we can't test this through normal request
                              reject(err);
                            }
                          }

                          return _context.abrupt("break", 34);

                        case 19:
                          if (!(locationURL === null)) {
                            _context.next = 21;
                            break;
                          }

                          return _context.abrupt("break", 34);

                        case 21:
                          if (!(request.counter >= request.follow)) {
                            _context.next = 25;
                            break;
                          }

                          reject(new FetchError(`maximum redirect reached at: ${request.url}`, 'max-redirect'));
                          finalize();
                          return _context.abrupt("return");

                        case 25:
                          // HTTP-redirect fetch step 6 (counter increment)
                          // Create a new Request object.
                          requestOpts = {
                            headers: new Headers(request.headers),
                            follow: request.follow,
                            counter: request.counter + 1,
                            agent: request.agent,
                            compress: request.compress,
                            method: request.method,
                            body: request.body,
                            signal: request.signal,
                            timeout: request.timeout
                          }; // HTTP-redirect fetch step 9

                          if (!(res.statusCode !== 303 && request.body && getTotalBytes(request) === null)) {
                            _context.next = 30;
                            break;
                          }

                          reject(new FetchError('Cannot follow redirect with body being a readable stream', 'unsupported-redirect'));
                          finalize();
                          return _context.abrupt("return");

                        case 30:
                          // HTTP-redirect fetch step 11
                          if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === 'POST') {
                            requestOpts.method = 'GET';
                            requestOpts.body = undefined;
                            requestOpts.headers.delete('content-length');
                          } // HTTP-redirect fetch step 15


                          resolve(fetch$1(new Request(locationURL, requestOpts, SESSION_COOKIES$1)));
                          finalize();
                          return _context.abrupt("return");

                        case 34:
                          // prepare response
                          res.once('end', function () {
                            if (signal) signal.removeEventListener('abort', abortAndFinalize);
                          });
                          body = res.pipe(new PassThrough$1());
                          response_options = {
                            url: request.url,
                            status: res.statusCode,
                            statusText: res.statusMessage,
                            headers: headers,
                            size: request.size,
                            timeout: request.timeout,
                            counter: request.counter
                          }; // HTTP-network fetch step 12.1.1.3

                          codings = headers.get('Content-Encoding'); // HTTP-network fetch step 12.1.1.4: handle content codings
                          // in following scenarios we ignore compression support
                          // 1. compression support is disabled
                          // 2. HEAD request
                          // 3. no Content-Encoding header
                          // 4. no content response (204)
                          // 5. content not modified response (304)

                          if (!(!request.compress || request.method === 'HEAD' || codings === null || res.statusCode === 204 || res.statusCode === 304)) {
                            _context.next = 42;
                            break;
                          }

                          response = new Response(body, response_options);
                          resolve(response);
                          return _context.abrupt("return");

                        case 42:
                          // For Node v6+
                          // Be less strict when decoding compressed responses, since sometimes
                          // servers send slightly invalid responses that are still accepted
                          // by common browsers.
                          // Always using Z_SYNC_FLUSH is what cURL does.
                          zlibOptions = {
                            flush: zlib.Z_SYNC_FLUSH,
                            finishFlush: zlib.Z_SYNC_FLUSH
                          }; // for gzip

                          if (!(codings == 'gzip' || codings == 'x-gzip')) {
                            _context.next = 48;
                            break;
                          }

                          body = body.pipe(zlib.createGunzip(zlibOptions));
                          response = new Response(body, response_options);
                          resolve(response);
                          return _context.abrupt("return");

                        case 48:
                          if (!(codings == 'deflate' || codings == 'x-deflate')) {
                            _context.next = 52;
                            break;
                          }

                          // handle the infamous raw deflate response from old servers
                          // a hack for old IIS and Apache servers
                          raw = res.pipe(new PassThrough$1());
                          raw.once('data', function (chunk) {
                            // see http://stackoverflow.com/questions/37519828
                            if ((chunk[0] & 0x0F) === 0x08) {
                              body = body.pipe(zlib.createInflate());
                            } else {
                              body = body.pipe(zlib.createInflateRaw());
                            }

                            response = new Response(body, response_options);
                            resolve(response);
                          });
                          return _context.abrupt("return");

                        case 52:
                          if (!(codings == 'br' && typeof zlib.createBrotliDecompress === 'function')) {
                            _context.next = 57;
                            break;
                          }

                          body = body.pipe(zlib.createBrotliDecompress());
                          response = new Response(body, response_options);
                          resolve(response);
                          return _context.abrupt("return");

                        case 57:
                          // otherwise, use response as-is
                          response = new Response(body, response_options);
                          resolve(response);

                        case 59:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x5) {
                  return _ref2.apply(this, arguments);
                };
              }());
              writeToStream(req, request);

            case 33:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[14, 20]]);
    }));

    return function (_x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }());
}
/**
 * Redirect code matching
 *
 * @param   Number   code  Status code
 * @return  Boolean
 */

fetch$1.isRedirect = function (code) {
  return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
};

window.fetch = fetch$1; // expose Promise

fetch$1.Promise = global.Promise;

module.exports = exports = fetch$1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = exports;
exports.Headers = Headers;
exports.Request = Request;
exports.Response = Response;
exports.FetchError = FetchError;
exports.FetchLocation = FetchLocation;
